<?xml version="1.0" encoding="UTF-8"?>
<!--
 * LICENCE[[
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1/CeCILL 2.O 
 *
 * The contents of this file are subject to the Mozilla Public License Version 
 * 1.1 (the "License"); you may not use this file except in compliance with 
 * the License. You may obtain a copy of the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
 * for the specific language governing rights and limitations under the 
 * License. 
 * 
 * The Original Code is kelis.fr code. 
 * 
 * The Initial Developer of the Original Code is 
 * antoine.pourchez@kelis.fr on behalf of USTL / SEMM (http://semm.univ-lille1.fr)
 * 
 * Portions created by the Initial Developer are Copyright (C) 2005 
 * the Initial Developer. All Rights Reserved. 
 * 
 * Contributor(s): 
 * 
 * 
 * Alternatively, the contents of this file may be used under the terms of 
 * either of the GNU General Public License Version 2 or later (the "GPL"), 
 * or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"), 
 * or the CeCILL Licence Version 2.0 (http://www.cecill.info/licences.en.html), 
 * in which case the provisions of the GPL, the LGPL or the CeCILL are applicable 
 * instead of those above. If you wish to allow use of your version of this file 
 * only under the terms of either the GPL or the LGPL, and not to allow others 
 * to use your version of this file under the terms of the MPL, indicate your 
 * decision by deleting the provisions above and replace them with the notice 
 * and other provisions required by the GPL or the LGPL. If you do not delete 
 * the provisions above, a recipient may use your version of this file under 
 * the terms of any one of the MPL, the GPL, the LGPL or the CeCILL.
 * ]]LICENCE
 -->
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:table="urn:oasis:names:tc:opendocument:xmlns:table:1.0"
	xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive"
	xmlns:office="urn:oasis:names:tc:opendocument:xmlns:office:1.0"
	xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0"
	xmlns:svg="urn:oasis:names:tc:opendocument:xmlns:svg-compatible:1.0"
	xmlns:sl="http://www.utc.fr/ics/scenari/v3/library"
	xmlns:fo="http://www.w3.org/1999/XSL/Format"
	xmlns:xlink="http://www.w3.org/1999/xlink"
	xmlns:java="http://xml.apache.org/xslt/java"
	xmlns:scOd="http://www.utc.fr/ics/scenari/v3/openDocument"
	xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0"
	xmlns:sc="http://www.utc.fr/ics/scenari/v3/core"
	exclude-result-prefixes="table sp office style svg sl fo xlink java scOd text sc ">
	<xsl:output omit-xml-declaration="yes" indent="no" method="xml" />
	<xsl:param name="vAgent" />
	<xsl:param name="vDialog" />
	<xsl:variable select="getIdNode(.)" name="idRootAgt" />
	<xsl:template match="*">
		<xsl:variable name="vInfosRes" select="resultatAgent('viewResource/genResSize')"/>
        <xsl:variable name="vWidth" select="substring-before(substring-after($vInfosRes, 'w='), ';')"/>
        <xsl:variable name="vHeight" select="substring-before(substring-after($vInfosRes, 'h='), ';')"/>
        <xsl:variable name="vExistRes" select="boolean($vInfosRes)"/>
        <xsl:comment> ### OBJECT ### infores MATH : <xsl:copy-of select="$vInfosRes"/></xsl:comment>
		 <xsl:choose>
            <xsl:when test="$vExistRes">
                <draw:frame xmlns:draw="urn:oasis:names:tc:opendocument:xmlns:drawing:1.0"
                    svg:height="{normalize-space($vHeight)}cm"
                    svg:width="{normalize-space($vWidth)}cm" svg:y="0cm" svg:x="0" draw:z-index="1"
                    text:anchor-type="as-char" draw:name="{local-name()}" draw:style-name="sfile_math_inline">
                    <xsl:element name="draw:object">
                        <xsl:attribute name="xlink:href">
                            <xsl:value-of select="resultatAgent('viewResource/odResPath')"/>
                        </xsl:attribute>
                        <xsl:attribute name="xlink:type">simple</xsl:attribute>
                        <xsl:attribute name="xlink:show">embed</xsl:attribute>
                        <xsl:attribute name="xlink:actuate">onLoad</xsl:attribute>
                    </xsl:element>
                </draw:frame>
                <scOd:resources odPath="{resultatAgent('viewResource//odResPath')}" path="dest:{resultatAgent('viewResource//genResUri')}" type="zip"/>
            </xsl:when>
            <xsl:otherwise>
                <scOd:error text="Ressource manquante" phase="generation" type="error">La ressource '<xsl:value-of select="resultatAgent('../elt_N8/UriResSource')"/>' est introuvable.</scOd:error>
            </xsl:otherwise>
        </xsl:choose>
	</xsl:template>
	
</xsl:stylesheet>