<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xalan="http://xml.apache.org/xalan" xmlns:java="http://xml.apache.org/xslt/java" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" exclude-result-prefixes="sc sp java xalan" version="1.0"><xsl:output omit-xml-declaration="yes" indent="no" method="xml"/><xsl:param name="vAgent"/><xsl:param name="vDialog"/><xsl:variable select="concat(getIdNode(..), '')" name="vIdObj"/><xsl:variable select="sp:*" name="vFields"/><xsl:template match="*"><script type="text/JavaScript">
var <xsl:value-of select="$vIdObj"/> = {

	fId : "<xsl:value-of select="getIdNode(..)"/>",
	fCurSeq : null,
	initSeq : function(pCodeSeq){
	try {
		if(pCodeSeq==null) return;
		if(this.fCurSeq!=null) this.closeSeq();
		this.fCurSeq = pCodeSeq;
		switch(this.fCurSeq) {

		case "play" : {
		var vForm = document.forms.<xsl:value-of select="$vIdObj"/>_form;
		this._Sol = {<xsl:for-each select="$vFields"><xsl:value-of select="si(@index, @index, 'field')"/>:{s:[<xsl:apply-templates mode="fillData_play"/>null],min:<xsl:call-template name="minScore_play"/>,max:<xsl:call-template name="maxScore_play"/>},</xsl:for-each>_:null};
		this.getSolIdx = function(pFieldIndex){
			var vF = this._Sol[pFieldIndex];
			var vVal = vForm[pFieldIndex].value;
			for (var i = 0; i &lt; vF.s.length-1; i++) if(vF.s[i].isMatch(vVal)) return i;
			return -1;
		};
		this.getFieldScore = function(pFieldIndex) {
			var vI = this.getSolIdx(pFieldIndex);
			if(vI &gt;= 0) return this._Sol[pFieldIndex].s[vI].score;
			return 0;
		};
		this.refreshResultInput = function(pInput){
			if(this._resultDisplay == "none") pInput.parentNode.className="";
			else {
				var vSol = this._Sol[pInput.name];
				var vRes = Math.round((this.getFieldScore(pInput.name) - vSol.min) / (vSol.max - vSol.min) * 1);
				pInput.parentNode.className= "assmntResult_" + vRes;
			}
		};
var vLoadRespSession = "";

		for (var i=0; i &lt; vForm.length; i++) {
			var vFi = vForm.elements[i];
			this.setInteraction(vFi, "enabled");
			vFi.value = vLoadRespSession == null ? "" : scServices.assmntMgr.getResponse(this.fId, vLoadRespSession, vFi.name) || "";
		}
	this.refreshResult("");


		this.setSolution('collapsed', 'collapsed');
this.setMode(document.getElementById("<xsl:value-of select="$vIdObj"/>_N_gExpln"), "collapsed");
this.setMode(document.getElementById("<xsl:value-of select="$vIdObj"/>_N_score"), "invisible");
this.setMode(document.getElementById("<xsl:value-of select="$vIdObj"/>_N_question"), "visible");
this.setToggleStatus(document.getElementById("<xsl:value-of select="$vIdObj"/>_S_N67"), false);
this.setToggleStatus(document.getElementById("<xsl:value-of select="$vIdObj"/>_S_N82"), false);
var vRespSession = "";
		if(scServices.assmntMgr.getCompletionStatus(this.fId, vRespSession)=="notAttempt") scServices.assmntMgr.setCompletionStatus(this.fId, vRespSession, "attempt");
		this.setResp = function(pInput) {
			scServices.assmntMgr.setResponse(this.fId, vRespSession, pInput.name, pInput.value);
			this.computeScore();
			scServices.assmntMgr.commit();
			this.refreshResultInput(pInput);
		}				

		this.computeScore = function() {

			this.fMinPts = 0;
			this.fMaxPts = 0;
			for(var vF in this._Sol) if(vF!="_") {this.fMinPts += this._Sol[vF].min; this.fMaxPts += this._Sol[vF].max;}
			this.fScorePts = <xsl:for-each select="$vFields">this.getFieldScore("<xsl:value-of select="si(@index, @index, 'field')"/>")+</xsl:for-each>0;

			//alert("score:::::"+this.fMinPts+" - "+this.fScorePts+" - "+this.fMaxPts);
var vScoreSession = "";
			if(this.fScorePts != null) scServices.assmntMgr.setPts(this.fId, vScoreSession, this.fMinPts, this.fScorePts, this.fMaxPts);

			this.refreshScoresFeedbacks();
		}

if(vRespSession != vLoadRespSession) for (var i=0; i &lt; vForm.length; i++) scServices.assmntMgr.setResponse(this.fId, vRespSession, vForm.elements[i].name, vForm.elements[i].value);
this.computeScore();

		scServices.assmntMgr.commit();
		break;
	}

		}
	}catch(e){alert("failed:::"+e)};
	},
	onActionNa5 : function(pButton){
		if(this.isDisabled(pButton)) return;
var vSess="";
scServices.assmntMgr.resetResponses(this.fId, vSess);
scServices.assmntMgr.setPts(this.fId, vSess, null, null, null); 
this.initSeq("play");

		scServices.assmntMgr.commit();
	},
	onActionN67 : function(pButton){
		if(this.isDisabled(pButton)) return;
		var vIsOn = this.isToggleOn(pButton);
		if(vIsOn) {
this.setMode(document.getElementById("<xsl:value-of select="$vIdObj"/>_N_score"), "invisible");

		} else {
this.setMode(document.getElementById("<xsl:value-of select="$vIdObj"/>_N_score"), "visible");

		}
		this.setToggleStatus(pButton, ! vIsOn);
		scServices.assmntMgr.commit();
	},
	onActionN82 : function(pButton){
		if(this.isDisabled(pButton)) return;
		var vIsOn = this.isToggleOn(pButton);
		if(vIsOn) {
this.setSolution('collapsed', 'collapsed'); this.refreshResult("none");this.setMode(document.getElementById("<xsl:value-of select="$vIdObj"/>_N_gExpln"), "collapsed");

		} else {
this.setSolution('collapsed', 'visible'); this.refreshResult("addClass");this.setMode(document.getElementById("<xsl:value-of select="$vIdObj"/>_N_gExpln"), "visible");

		}
		this.setToggleStatus(pButton, ! vIsOn);
		scServices.assmntMgr.commit();
	},
	fct_play : function(){
this.initSeq("play");

	},
	fct_reset : function(){
var vSess="";
scServices.assmntMgr.resetResponses(this.fId, vSess);
scServices.assmntMgr.setPts(this.fId, vSess, null, null, null); 
this.initSeq("play");

	},
	fct_displaySol : function(){
this.setSolution('collapsed', 'visible'); this.setMode(document.getElementById("<xsl:value-of select="$vIdObj"/>_N_gExpln"), "visible");

	},
	fct_cleanSol : function(){
this.setSolution('collapsed', 'collapsed'); this.setMode(document.getElementById("<xsl:value-of select="$vIdObj"/>_N_gExpln"), "collapsed");

	},
	setMode : function(pElt, pMode){
		if(!pElt) return;
		switch(pMode) {
		case "collapsed" :
			pElt.style.display = "none";
			break;
		case "invisible" :
			pElt.style.display = "";
			pElt.style.visibility = "hidden";
			break;
		case "enabled" : 
			if(pElt.className.indexOf("buttonDisabled")&gt;=0) pElt.className = pElt.className.replace("buttonDisabled", "");
			pElt.setAttribute("href", "#");
		case "disabled" : 
			if(pMode=="disabled") {
				if(pElt.className.indexOf("buttonDisabled")&lt;0) pElt.className = pElt.className+" buttonDisabled";
				pElt.removeAttribute("href");
			}
		default :
			pElt.style.display = "";
			pElt.style.visibility = "";
		}
	},
	isDisabled : function(pButton){
		return pButton==null || pButton.className.indexOf("buttonDisabled")&gt;=0;
	},
	setToggleStatus : function(pButton, pOn){
		if(pButton==null) return;
		if(pOn){ 
			var vIdx = pButton.className.lastIndexOf("toggleButtonOff");
			pButton.className = (vIdx&gt;0 ? pButton.className.substring(0, vIdx) :  pButton.className) + " toggleButtonOn";
		} else {
			var vIdx = pButton.className.lastIndexOf("toggleButtonOn");
			pButton.className = (vIdx&gt;0 ? pButton.className.substring(0, vIdx) :  pButton.className) + " toggleButtonOff";
		}
	},
	isToggleOn : function(pButton){
		return pButton!=null &amp;&amp; pButton.className.indexOf("toggleButtonOn")&gt;=0;
	},
	
	closeSeq: function(){
		vForm = document.forms.<xsl:value-of select="$vIdObj"/>_form;
		switch(this.fCurSeq) {

	case "play" : {

		break;
	}

		}
		this.fCurSeq = null;
	},
	getOnLoadSeq:function() {

			return "play";

	return null;
	},

	refreshScoresFeedbacks : function(){
		

		var vScoreNode = document.getElementById("<xsl:value-of select="$vIdObj"/>_SNc5");

		var vScore = (Math.round((this.fScorePts-this.fMinPts) / (this.fMaxPts-this.fMinPts) * 100) * 1)+ 0;
if(vScore &gt; 99 &amp;&amp; true) {
			vScoreNode.innerHTML = "&lt;span&gt;" + vScore + "% de bonnes réponses&lt;/span&gt;";
			vScoreNode.className = "answBest";
		} else if(vScore &gt; 49 &amp;&amp; vScore &lt;= 99 &amp;&amp; true) {
			vScoreNode.innerHTML = "&lt;span&gt;" + vScore + "% de bonnes réponses&lt;/span&gt;";
			vScoreNode.className = "answGood";
		} else if(vScore &lt;= 49 &amp;&amp; true) {
			vScoreNode.innerHTML = "&lt;span&gt;" + vScore + "% de bonnes réponses&lt;/span&gt;";
			vScoreNode.className = "answBad";
		} else  {
			vScoreNode.innerHTML = "";
			vScoreNode.className = "";
		}

	},
	setSolution : function(pIfRight, pIfNotBest){
		for(var vF in this._Sol) if(vF != "_") this.setMode(document.getElementById("<xsl:value-of select="$vIdObj"/>_X_"+vF), this.getSolIdx(vF)==0 ? pIfRight || "collapsed" : pIfNotBest || "collapsed");
	},
	setInteraction : function(pElt, pMode){
		if(!pElt) return;
		switch(pMode) {
		case "collapsed" :
			pElt.style.display = "none";
			break;
		case "invisible" :
			pElt.style.display = "";
			pElt.style.visibility = "hidden";
			break;
		case "enabled" : 
		case "disabled" : 
			pElt.disabled = (pMode=="disabled");
		default :
			pElt.style.display = "";
			pElt.style.visibility = "visible";
		}
	},
	refreshResult : function(pMode){
		this._resultDisplay = pMode || "none";
		var vForm = document.forms.<xsl:value-of select="$vIdObj"/>_form;
		for (var i=0; i &lt; vForm.length; i++) this.refreshResultInput(vForm.elements[i]);
	},
	onLoad: function(){
		this.initSeq(this.getOnLoadSeq()); 
		var vNodeRoot = document.getElementById("<xsl:value-of select="$vIdObj"/>_A");
		vNodeRoot.style.display = "block"; 
	},
	onUnload: function(){
		this.closeSeq();
	},
	loadSortKey: "A",
	unloadSortKey: "A"
};

scOnLoads[scOnLoads.length] = <xsl:value-of select="$vIdObj"/>;
scOnUnloads[scOnUnloads.length] = <xsl:value-of select="$vIdObj"/>;
</script><div style="display:none;" id="{$vIdObj}_A"><div class="bkSolResOut"><div class="bkSolResFra1"><div class="bkSolResFra2"><div class="bkSolResFra3"><div class="bkSolResCo"><div class="btnScore"><a onclick="{$vIdObj}.onActionN67(this); return false;" href="#" title="Calculer le score" class="btnQuiz " id="{$vIdObj}_S_N67"><span class="btnQuizCaption">Score</span></a></div><div class="btnSol"><a onclick="{$vIdObj}.onActionN82(this); return false;" href="#" title="Afficher ou masquer les solutions" class="btnQuiz " id="{$vIdObj}_S_N82"><span class="btnQuizCaption">Solutions</span></a></div><div class="btnReset"><a onclick="{$vIdObj}.onActionNa5(this); return false;" href="#" title="Effacer les réponses" class="btnQuiz "><span class="btnQuizCaption">Recommencer</span></a></div><div class="scoreBox"><div class="score " id="{$vIdObj}_N_score"><div id="{$vIdObj}_SNc5"><span/></div></div></div></div></div></div></div></div><div class="headerQ"><div id="{$vIdObj}_N_question" class="question"><xsl:for-each select="sc:question">[![agent=@<xsl:value-of select="getIdNode(.)"/>/xhtmlContent]!]</xsl:for-each></div></div><form id="{$vIdObj}_form" name="{$vIdObj}_form" action="javascript:void(0);"><xsl:apply-templates mode="inputZoneNe0" select="sp:*"/></form><xsl:for-each select="sc:globalExplanation"><div class="gExpln " id="{$vIdObj}_N_gExpln">[![agent=@<xsl:value-of select="getIdNode(.)"/>/xhtmlContent]!]</div></xsl:for-each></div></xsl:template><xsl:template mode="inputZoneNe0" match="sp:asw[sc:SFSolution]"><xsl:variable select="'field'" name="vIndex"/><div class="exoAsw"><span><input onblur="{$vIdObj}.setResp(this);" name="{$vIndex}" type="text" class="exoInput "/></span><span id="{$vIdObj}_X_{$vIndex}" class="exoSol "><span><xsl:value-of select="sc:SFSolution[not(sc:score) or max(following-sibling::sc:SFSolution/sc:score/@value) &lt;= sc:score/@value]/sc:value[1]/text()"/></span></span></div></xsl:template><xsl:template mode="inputZoneNe0" match="node()"/><xsl:template mode="fillData_play" match="sc:SFSolution">{isMatch:function(pResp){<xsl:call-template name="getMatch_play"/>}, score:<xsl:call-template name="getScore_play"/>},</xsl:template><xsl:template mode="fillData_play" match="sc:undefinedResponse">{isMatch:function(pResp){return true}, score:<xsl:call-template name="getScore_play"/>},</xsl:template><xsl:template mode="fillData_play" match="node()"/><xsl:template name="getMatch_play">if(!pResp) return false; pResp=pResp.toUpperCase(); return <xsl:for-each select="sc:value">'<xsl:value-of select="chaineProtegeJs(java:toUpperCase(java:trim(normalize-space(.))))"/>'==pResp || </xsl:for-each>false;</xsl:template><xsl:template name="getScore_play"><xsl:choose><xsl:when test="sc:score/@value"><xsl:value-of select="sc:score/@value"/></xsl:when><xsl:otherwise><xsl:value-of select="si(self::sc:undefinedResponse,'0', '1')"/></xsl:otherwise></xsl:choose></xsl:template><xsl:template name="minScore_play"><xsl:variable name="vTransfMin"><xsl:choose><xsl:otherwise>0</xsl:otherwise></xsl:choose></xsl:variable><xsl:variable name="vList"><l><xsl:for-each select="*"><a><xsl:value-of select="si(sc:score/@value, sc:score/@value, $vTransfMin)"/></a></xsl:for-each><xsl:if test="count(sc:undefinedResponse)=0"><a><xsl:value-of select="$vTransfMin"/></a></xsl:if></l></xsl:variable><xsl:value-of select="min(xalan:nodeset($vList)/l/*)"/></xsl:template><xsl:template name="maxScore_play"><xsl:variable name="vTransfMax"><xsl:choose><xsl:otherwise>1</xsl:otherwise></xsl:choose></xsl:variable><xsl:variable name="vList"><l><xsl:for-each select="*"><a><xsl:value-of select="si(sc:score/@value, sc:score/@value, $vTransfMax)"/></a></xsl:for-each></l></xsl:variable><xsl:value-of select="max(xalan:nodeset($vList)/l/*)"/></xsl:template></xsl:stylesheet>