<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:repeat="com.scenari.xsldom.xalan.lib.Repeat" xmlns:xalan="http://xml.apache.org/xalan" xmlns:java="http://xml.apache.org/xslt/java" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" extension-element-prefixes="repeat" exclude-result-prefixes="sc xalan java" version="1.0"><xsl:output omit-xml-declaration="yes" indent="no" method="xml"/><xsl:param name="vComp"/><xsl:variable select="concat(getIdNode(..), '_Asol')" name="vIdObj"/><xsl:variable select="sc:group/sc:label" name="vLabels"/><xsl:variable name="vListCountMaxLabels"><a><xsl:for-each select="sc:group"><c><xsl:value-of select="count(sc:label)"/></c></xsl:for-each></a></xsl:variable><xsl:variable select="max(xalan:nodeset($vListCountMaxLabels)/a/c)" name="vCountMaxLabels"/><xsl:template match="*"><script type="text/JavaScript">
var <xsl:value-of select="$vIdObj"/> = {

	fId : "<xsl:value-of select="getIdNode(..)"/>",
	fCurSeq : null,
	initSeq : function(pCodeSeq){
	try {
		if(pCodeSeq==null) return;
		if(this.fCurSeq!=null) this.closeSeq();
		this.fCurSeq = pCodeSeq;
		switch(this.fCurSeq) {
case "init" : {

	this.refreshResult = function(pDisplay){
		if(pDisplay) this.fResultDisplay = pDisplay;
		if(this.fResultDisplay == "none") for(var i=this.fLabels.length -1; i &gt;=0; i--)  scDragMgr.helpers.delClass(this.fLabels[i],"ddLabel_Right","ddLabel_Wrong");
		else for(var i=this.fLabels.length -1; i &gt;=0; i--) {
			var vLabel = this.fLabels[i];

			var vOldClass = (vLabel.sG == vLabel.rG ) ? "ddLabel_Wrong" : "ddLabel_Right";
			var vNewClass = (vLabel.sG == vLabel.rG ) ? "ddLabel_Right" : "ddLabel_Wrong";

			scDragMgr.helpers.switchClass(vLabel, vOldClass, vNewClass);
		}
	};
var vLoadRespSession = "eval";

		for(var i = this.fLabels.length - 1; i &gt;=0; i--) scDragMgr.setDraggable(this.fLabels[i], false);
		this.load(vLoadRespSession);
		this.synch();
	this.fResultDisplay = "addClass";

var vLoadScoreSession = "eval";
		this.fMinPts = scServices.assmntMgr.getMinPts(this.fId, vLoadScoreSession);
		this.fScorePts = scServices.assmntMgr.getScorePts(this.fId, vLoadScoreSession);
		this.fMaxPts = scServices.assmntMgr.getMaxPts(this.fId, vLoadScoreSession);
this.setMode(document.getElementById("<xsl:value-of select="$vIdObj"/>_N_quest"), "visible");
this.setMode(document.getElementById("<xsl:value-of select="$vIdObj"/>_N_question"), "visible");
this.fRespSession = null;

		this.computeScore = function() {

		this.refreshScoresFeedbacks();
		this.refreshResult();
	}


		this.computeScore();

		scServices.assmntMgr.commit();
		break;
	}

		}
	}catch(e){alert("failed:::"+e)};
	},
	setMode : function(pElt, pMode){
		if(!pElt) return;
		switch(pMode) {
		case "collapsed" :
			pElt.style.display = "none";
			break;
		case "invisible" :
			pElt.style.display = "";
			pElt.style.visibility = "hidden";
			break;
		case "enabled" : 
			if(pElt.className.indexOf("buttonDisabled")&gt;=0) pElt.className = pElt.className.replace("buttonDisabled", "");
			pElt.setAttribute("href", "#");
		case "disabled" : 
			if(pMode=="disabled") {
				if(pElt.className.indexOf("buttonDisabled")&lt;0) pElt.className = pElt.className+" buttonDisabled";
				pElt.removeAttribute("href");
			}
		default :
			pElt.style.display = "";
			pElt.style.visibility = "";
		}
	},
	isDisabled : function(pButton){
		return pButton==null || pButton.className.indexOf("buttonDisabled")&gt;=0;
	},
	setToggleStatus : function(pButton, pOn){
		if(pButton==null) return;
		if(pOn){ 
			var vIdx = pButton.className.lastIndexOf("toggleButtonOff");
			pButton.className = (vIdx&gt;0 ? pButton.className.substring(0, vIdx) :  pButton.className) + " toggleButtonOn";
		} else {
			var vIdx = pButton.className.lastIndexOf("toggleButtonOn");
			pButton.className = (vIdx&gt;0 ? pButton.className.substring(0, vIdx) :  pButton.className) + " toggleButtonOff";
		}
	},
	isToggleOn : function(pButton){
		return pButton!=null &amp;&amp; pButton.className.indexOf("toggleButtonOn")&gt;=0;
	},
	
	closeSeq: function(){
		vForm = document.forms.<xsl:value-of select="$vIdObj"/>_form;
		switch(this.fCurSeq) {
case "init" : {
		this.refreshResult("none");

		break;
	}

		}
		this.fCurSeq = null;
	},
	getOnLoadSeq:function() {

			return "init";

	return null;
	},

	saveResp:function(pSession){
		if(pSession==null) return;
		var vLabel = this.fLabels[0];
		var vStr = "[{g:" + vLabel.rG + ",offs:" + vLabel.rO + "," + scDragMgr.saveLabelPos(vLabel) + "}";
		for(var i=1, len=this.fLabels.length; i &lt; len; i++) {
			vLabel = this.fLabels[i];
			vStr += ",{g:" + vLabel.rG + ",offs:" + vLabel.rO + "," + scDragMgr.saveLabelPos(vLabel) + "}";
		}
		vStr+="]";
		scServices.assmntMgr.setResponse(this.fId, pSession, "pos", vStr);
	},
	load:function(pSession){
		var vStr = (pSession!=null) ? scServices.assmntMgr.getResponse(this.fId, pSession, "pos") : null;
		for(var i=this.fGroupsC.length -1; i &gt;=0; i--) {
			var vGroup = this.fGroupsC[i];
			for(var j=vGroup.length-1; j &gt;=0; j--) vGroup[j].labelsToAdd = [];
		}
		if(vStr) {
						var vList = eval(vStr);
			for(var i=0, len=this.fLabels.length; i &lt; len; i++) {
				var vLabelToAdd = vList[i];
				vLabelToAdd.label = this.fLabels[i];
				var vGroupC = this.fGroupsC[vLabelToAdd.g];
				if(vGroupC.length == 1) vGroupC[0].labelsToAdd[vLabelToAdd.offs] = vLabelToAdd; 
				else vGroupC[vLabelToAdd.offs].labelsToAdd.push(vLabelToAdd);
			}
		} else {
						var vBasketC = this.fGroupsC[0];
			for(var i=vBasketC.length-1; i &gt;=0; i--) for(var j=0, vLen=vBasketC[i]._Labels.length; j &lt; vLen; j++) vBasketC[i].labelsToAdd.push({label:vBasketC[i]._Labels[j]});
		}
		scDragMgr.repopulateContainers("<xsl:value-of select="$vIdObj"/>");
	},
	synch:function(){
		for(var i=this.fGroupsC.length -1; i &gt;=0; i--) {
			var vGroup = this.fGroupsC[i];
			var vOffset = 0;
			for(var j=0, vLenJ=vGroup.length; j &lt; vLenJ; j++) {
				var vItems = scDragMgr.getLabels(vGroup[j]);
				var vLenK = vItems.length;
								if(vLenK == 0) vOffset++;
				else for(var k=0; k &lt; vLenK; k++) {
					vItems[k].rG = i;
					vItems[k].rO = vOffset++;
				}
			}
		}
	},
	refreshScoresFeedbacks : function(){

		var vScoreNode = document.getElementById("<xsl:value-of select="$vIdObj"/>_SN42");

		var vScore = (Math.round((this.fScorePts-this.fMinPts) / (this.fMaxPts-this.fMinPts) * 100) * 1)+ 0;
if(vScore &gt; 99 &amp;&amp; true) {
			vScoreNode.innerHTML = "&lt;span&gt;Félicitations, vous avez obtenu " + vScore + "% de bonnes réponses.&lt;/span&gt;";
			vScoreNode.className = "answBest";
		} else if(vScore &lt;= 50 &amp;&amp; true) {
			vScoreNode.innerHTML = "&lt;span&gt;Vous avez obtenu " + vScore + "% de bonnes réponses.&lt;/span&gt;";
			vScoreNode.className = "answBad";
		} else if(true) {
			vScoreNode.innerHTML = "&lt;span&gt;Vous avez obtenu " + vScore + "% de bonnes réponses.&lt;/span&gt;";
			vScoreNode.className = "answGood";
		} else  {
			vScoreNode.innerHTML = "";
			vScoreNode.className = "";
		}

	},
	onLoad: function(){
	try{
		var onChange = function() {
<xsl:value-of select="$vIdObj"/>.synch();
<xsl:value-of select="$vIdObj"/>.computeScore();
<xsl:value-of select="$vIdObj"/>.saveResp(<xsl:value-of select="$vIdObj"/>.fRespSession);
			scServices.assmntMgr.commit();
		}
		this.fLabels = [];
		var vLabel, vC;
scDragMgr.makeContainer("<xsl:value-of select="$vIdObj"/>", document.getElementById("<xsl:value-of select="$vIdObj"/>_S_N6e"), vC = document.getElementById("<xsl:value-of select="$vIdObj"/>_S_N70"), document.getElementById("<xsl:value-of select="$vIdObj"/>_S_N7b")).setMode(vC, 'append', -1).setDragOverClass(vC, 'ddBasketDragOver');
<xsl:for-each select="$vLabels">vLabel = document.getElementById("<xsl:value-of select="$vIdObj"/>_L<xsl:value-of select="generate-id()"/>");
	this.fLabels.push(vLabel);
	vLabel.sO=<xsl:value-of select="count(preceding-sibling::sc:label)"/>;
vLabel.sG=<xsl:value-of select="count(../preceding-sibling::sc:group)+1"/>;
scDragMgr.makeDraggableLabel("<xsl:value-of select="$vIdObj"/>", vLabel).setCallback(vLabel, onChange).setDragClass(vLabel, '');
</xsl:for-each><xsl:for-each select="sc:group">scDragMgr.makeContainer("<xsl:value-of select="$vIdObj"/>", document.getElementById("<xsl:value-of select="$vIdObj"/>_NN8c_<xsl:value-of select="generate-id()"/>"), vC = document.getElementById("<xsl:value-of select="$vIdObj"/>_NN93_<xsl:value-of select="generate-id()"/>"), document.getElementById("<xsl:value-of select="$vIdObj"/>_NN95_<xsl:value-of select="generate-id()"/>")).setMode(vC, 'append', -1).setDragOverClass(vC, 'ddCatchDragOver');
</xsl:for-each><xsl:for-each select="sc:group"/>this.fGroupsC = [scDragMgr.getContainers("<xsl:value-of select="$vIdObj"/>", document.getElementById("<xsl:value-of select="$vIdObj"/>_L"))<xsl:for-each select="sc:group">,scDragMgr.getContainers("<xsl:value-of select="$vIdObj"/>", document.getElementById("<xsl:value-of select="$vIdObj"/>_R<xsl:value-of select="generate-id()"/>"))</xsl:for-each>];
		for(var i = this.fGroupsC[0].length-1; i &gt;=0; i--) this.fGroupsC[0][i]._Labels = scDragMgr.getLabels(this.fGroupsC[0][i]);
		this.initSeq(this.getOnLoadSeq()); 
		var vNodeRoot = document.getElementById("<xsl:value-of select="$vIdObj"/>_A");
		vNodeRoot.style.display = "block"; 
	}catch(e){console.log(e);}
	},
	onUnload: function(){
		this.closeSeq();
	},
	loadSortKey: "A",
	unloadSortKey: "A"
};

scOnLoads[scOnLoads.length] = <xsl:value-of select="$vIdObj"/>;
scOnUnloads[scOnUnloads.length] = <xsl:value-of select="$vIdObj"/>;
</script><div style="display:none;" id="{$vIdObj}_A"><div class="evalSol"><div id="{$vIdObj}_N_quest" class="question"><h1 class="question_ti"><span>Enoncé</span></h1><div id="{$vIdObj}_N_question" class="question_co"><xsl:for-each select="sc:question">[![agent=@<xsl:value-of select="getIdNode(.)"/>/xhtmlContent]!]</xsl:for-each></div></div><div class="score"><h1 class="score_ti"><span>Résultat</span></h1><div class="score_co"><div class="scoreEval "><div id="{$vIdObj}_SN42"><span/></div></div></div></div><div class="sol"><h1 class="sol_ti"><span>Correction</span></h1><div class="sol_co"><table class="mtTable"><tr><td class="mtTdBasketSol"/><td class="mtTdHeading">Votre réponse</td><td class="mtTdHeading">Solution</td></tr><tr><td class="mtTdBasketSol"><div id="{$vIdObj}_L" class="ddBasket "><div id="{$vIdObj}_S_N6e" class="ddBasketCatch "><div id="{$vIdObj}_S_N70" class="ddBasketCont "><xsl:variable select="java:com.scenari.s.fw.utils.RandomList.new()" name="vRN72"/><xsl:for-each select="$vLabels"><xsl:sort data-type="number" select="java:nextInt($vRN72)"/><div id="{$vIdObj}_L{generate-id()}" class="mtLabel ">[![agent=@<xsl:value-of select="getIdNode(.)"/>/xhtmlContent]!]</div></xsl:for-each></div><div id="{$vIdObj}_S_N7b" class="ddBasketIfEmpty "><span>Plus d&apos;éléments à catégoriser</span></div><div class="ddBasketEnd"/></div></div></td><td class="mtTdSol"><xsl:for-each select="sc:group"><div id="{$vIdObj}_R{generate-id()}" class="ddRepArea "><div id="{$vIdObj}_NN8c_{generate-id()}" class="ddDropCatch "><div class="ddDropTi"><xsl:for-each select="sc:target">[![agent=@<xsl:value-of select="getIdNode(.)"/>/xhtmlContent]!]</xsl:for-each></div><div id="{$vIdObj}_NN93_{generate-id()}" class="ddDropCont "/><div id="{$vIdObj}_NN95_{generate-id()}" class="ddDropContIfEmpty "><span>Déposez ici</span></div><div class="ddCatchDragEnd"/></div></div></xsl:for-each></td><td class="mtTdSol"><xsl:for-each select="sc:group"><div id="{$vIdObj}_NNa5_{generate-id()}" class="ddRepArea "><div class="ddDropCatch"><div class="ddDropTi"><xsl:for-each select="sc:target">[![agent=@<xsl:value-of select="getIdNode(.)"/>/xhtmlContent]!]</xsl:for-each></div><div class="ddDropCont"><xsl:for-each select="sc:label"><div class="mtLabelSol">[![agent=@<xsl:value-of select="getIdNode(.)"/>/xhtmlContent]!]</div></xsl:for-each></div><div class="ddCatchDragEnd"/></div></div></xsl:for-each></td></tr></table></div></div><xsl:for-each select="sc:globalExplanation"><div class="explain "><h1 class="explain_ti"><span>Explications</span></h1><div class="explain_co">[![agent=@<xsl:value-of select="getIdNode(.)"/>/xhtmlContent]!]</div></div></xsl:for-each></div></div></xsl:template></xsl:stylesheet>