<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" exclude-result-prefixes="sc" version="1.0"><xsl:output omit-xml-declaration="yes" indent="no" method="xml"/><xsl:param name="vComp"/><xsl:variable select="concat(getIdNode(..), '_Asol')" name="vIdObj"/><xsl:template match="*"><script type="text/JavaScript">
var <xsl:value-of select="$vIdObj"/> = {

	fId : "<xsl:value-of select="getIdNode(..)"/>",
	fCurSeq : null,
	initSeq : function(pCodeSeq){
	try {
		if(pCodeSeq==null) return;
		if(this.fCurSeq!=null) this.closeSeq();
		this.fCurSeq = pCodeSeq;
		switch(this.fCurSeq) {
case "" : {
		var vForm = document.forms.<xsl:value-of select="$vIdObj"/>_form;
		for (var i=0; i &lt; vForm.length; i++) {
			vForm.elements[i].disabled = true;
			vForm.elements[i].checked = false;
		}

var vLoadRespSession = "eval";
for (var i=0; i &lt; vForm.length; i++) {
			var vInput = vForm.elements[i];
			vInput.checked = scServices.assmntMgr.getResponse(this.fId, vLoadRespSession, vInput.value);
		}
var vLoadScoreSession = "eval";
		this.fMinPts = scServices.assmntMgr.getMinPts(this.fId, vLoadScoreSession);
		this.fScorePts = scServices.assmntMgr.getScorePts(this.fId, vLoadScoreSession);
		this.fMaxPts = scServices.assmntMgr.getMaxPts(this.fId, vLoadScoreSession);

		this.setSolution(true);
this.setMode(document.getElementById("<xsl:value-of select="$vIdObj"/>_N_quest"), "visible");
this.setMode(document.getElementById("<xsl:value-of select="$vIdObj"/>_N_question"), "visible");
<xsl:for-each select="sc:choices/sc:choice">this.setMode(document.getElementById("<xsl:value-of select="$vIdObj"/>_N<xsl:value-of select="count(preceding-sibling::sc:choice)"/>_choice"), "visible");
</xsl:for-each><xsl:for-each select="sc:choices/sc:choice">this.setMode(document.getElementById("<xsl:value-of select="$vIdObj"/>_N<xsl:value-of select="count(preceding-sibling::sc:choice)"/>_label"), "visible");
</xsl:for-each>this.setResp = function(pInput, pIdx) {

			this.computeScore();
			scServices.assmntMgr.commit();
		}	

		this.computeScore = function() {

			this.refreshScoresFeedbacks();
		}

this.computeScore();

		scServices.assmntMgr.commit();
		break;
	}

		}
	}catch(e){alert("failed:::"+e)};
	},
	setMode : function(pElt, pMode){
		if(!pElt) return;
		switch(pMode) {
		case "collapsed" :
			pElt.style.display = "none";
			break;
		case "invisible" :
			pElt.style.display = "";
			pElt.style.visibility = "hidden";
			break;
		case "enabled" : 
			if(pElt.className.indexOf("buttonDisabled")&gt;=0) pElt.className = pElt.className.replace("buttonDisabled", "");
			pElt.setAttribute("href", "#");
		case "disabled" : 
			if(pMode=="disabled") {
				if(pElt.className.indexOf("buttonDisabled")&lt;0) pElt.className = pElt.className+" buttonDisabled";
				pElt.removeAttribute("href");
			}
		default :
			pElt.style.display = "";
			pElt.style.visibility = "";
		}
	},
	isDisabled : function(pButton){
		return pButton==null || pButton.className.indexOf("buttonDisabled")&gt;=0;
	},
	setToggleStatus : function(pButton, pOn){
		if(pButton==null) return;
		if(pOn){ 
			var vIdx = pButton.className.lastIndexOf("toggleButtonOff");
			pButton.className = (vIdx&gt;0 ? pButton.className.substring(0, vIdx) :  pButton.className) + " toggleButtonOn";
		} else {
			var vIdx = pButton.className.lastIndexOf("toggleButtonOn");
			pButton.className = (vIdx&gt;0 ? pButton.className.substring(0, vIdx) :  pButton.className) + " toggleButtonOff";
		}
	},
	isToggleOn : function(pButton){
		return pButton!=null &amp;&amp; pButton.className.indexOf("toggleButtonOn")&gt;=0;
	},
	
	closeSeq: function(){
		vForm = document.forms.<xsl:value-of select="$vIdObj"/>_form;
		switch(this.fCurSeq) {

	case "" : {

		break;
	}

		}
		this.fCurSeq = null;
	},
	getOnLoadSeq:function() {

			return "";

	return null;
	},

	refreshScoresFeedbacks : function(){
		

		var vScoreNode = document.getElementById("<xsl:value-of select="$vIdObj"/>_SN40");

		var vStep = 1;
		var vScore = Math.round(this.fScorePts / vStep);
		function scoreStr(pVal){
			return new Number(pVal).toFixed(0);
		}
if(vScore &lt;= 0 &amp;&amp; true) {
			vScoreNode.innerHTML = "Votre réponse est incorrecte."+"";
			vScoreNode.className = "answBad";
		} else if(true) {
			vScoreNode.innerHTML = "Votre réponse est juste."+"";
			vScoreNode.className = "answBest";
		} else  {
			vScoreNode.innerHTML = "";
			vScoreNode.className = "";
		}

	},
	solIsShown : false,
	setSolution : function(pShown){
		var vTR = document.forms.<xsl:value-of select="$vIdObj"/>_form.firstChild;
		while(vTR.nodeType!=1) vTR = vTR.nextSibling;
		vTR = vTR.firstChild;
		while(vTR.nodeType!=1) vTR = vTR.nextSibling;
		vTR = vTR.firstChild;
		while(vTR.nodeType!=1) vTR = vTR.nextSibling;
		if(!pShown &amp;&amp; this.solIsShown) {
			while(vTR) {
				if(vTR.nodeName=="TR") {
					var vOffs = vTR.className.indexOf("assmntSol");
					if(vOffs&gt;=0) vTR.className = vTR.className.substring(0, vOffs) + vTR.className.substring(vOffs+14);
				}
				vTR = vTR.nextSibling;
			}
		} else if(pShown &amp;&amp; ! this.solIsShown) {
<xsl:for-each select="sc:choices/sc:choice">
			while(vTR.nodeName!="TR") vTR = vTR.nextSibling;
			vTR.className = "<xsl:value-of select="si(@solution='checked', 'assmntSolCheck ', 'assmntSolUnche ')"/>" + vTR.className;
			vTR = vTR.nextSibling;
</xsl:for-each>
		}
		this.solIsShown = pShown;
	},
	onLoad: function(){
		this.initSeq(this.getOnLoadSeq()); 
		var vNodeRoot = document.getElementById("<xsl:value-of select="$vIdObj"/>_A");
		vNodeRoot.style.display = "block"; 
	},
	onUnload: function(){
		this.closeSeq();
	},
	loadSortKey: "A",
	unloadSortKey: "A"
};

scOnLoads[scOnLoads.length] = <xsl:value-of select="$vIdObj"/>;
scOnUnloads[scOnUnloads.length] = <xsl:value-of select="$vIdObj"/>;
</script><div style="display:none;" id="{$vIdObj}_A"><div class="evalSol"><div id="{$vIdObj}_N_quest" class="question"><h1 class="question_ti"><span>Enoncé</span></h1><div id="{$vIdObj}_N_question" class="question_co"><xsl:for-each select="sc:question">[![agent=@<xsl:value-of select="getIdNode(.)"/>/xhtmlContent]!]</xsl:for-each></div></div><div class="score"><h1 class="score_ti"><span>Résultat</span></h1><div class="score_co"><div class="scoreEval "><div id="{$vIdObj}_SN40"><span/></div></div></div></div><div class="sol"><h1 class="sol_ti"><span>Correction</span></h1><div class="sol_co"><form id="{$vIdObj}_form" name="{$vIdObj}_form" action=""><table class="choiceList "><tbody><xsl:for-each select="sc:choices/sc:choice"><xsl:variable select="count(preceding-sibling::sc:choice)" name="vIndex"/><xsl:variable select="concat($vIdObj, '_', $vIndex)" name="vIdChoice"/><tr class="choiceList_ch "><td class="choiceList_in "><input onclick="{$vIdObj}.setResp(this, {$vIndex});" value="{$vIndex}" id="{$vIdChoice}" name="{$vIdChoice}" type="checkbox"/></td><td class="choiceList_la "><div id="{$vIdObj}_N{$vIndex}_choice" class="choice"><div id="{$vIdObj}_N{$vIndex}_label" class="label"><xsl:for-each select="sc:choiceLabel">[![agent=@<xsl:value-of select="getIdNode(.)"/>/xhtmlContent]!]</xsl:for-each></div><xsl:for-each select="sc:choiceExplanation"><div class="choiceExplain ">[![agent=@<xsl:value-of select="getIdNode(.)"/>/xhtmlContent]!]</div></xsl:for-each></div></td></tr></xsl:for-each></tbody></table></form></div></div><xsl:for-each select="sc:globalExplanation"><div class="explain "><h1 class="explain_ti"><span>Explications</span></h1><div class="explain_co">[![agent=@<xsl:value-of select="getIdNode(.)"/>/xhtmlContent]!]</div></div></xsl:for-each></div></div></xsl:template></xsl:stylesheet>