<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:lxslt="http://xml.apache.org/xslt" xmlns:redirect="com.scenari.xsldom.xalan.lib.Redirect" xmlns:java="http://xml.apache.org/xslt/java" extension-element-prefixes="redirect java lxslt ">
<xsl:output method="xml" indent="no"/>
<xsl:param name="vDialog"/>
<xsl:param name="vAgent"/>

<xsl:template match="alternative"><xsl:apply-templates/></xsl:template>
<xsl:template match="@lookForAlt"><xsl:attribute name="alt"><xsl:value-of select="si(.='', ancestor::alternative/@alt, .)"/></xsl:attribute></xsl:template>	
	

<xsl:template match="/"><xsl:apply-overlays/><xsl:apply-templates select="node()"/></xsl:template>
<xsl:template match="body">
<xsl:copy>
<xsl:apply-templates select="@*"/>
<xsl:apply-overlays/>
<xsl:apply-templates/>
<xsl:apply-overlays select="." mode="endTags"/>
</xsl:copy>
</xsl:template>
<xsl:template match="zoneContent"><xsl:apply-overlays/><xsl:apply-templates/></xsl:template>
<xsl:template match="ifText"><xsl:if test="descendant::text()[string-length(normalize-space())&gt;0] or descendant::img or descendant::object"><xsl:apply-templates/></xsl:if></xsl:template>
<xsl:template match="hx"><xsl:variable name="vCount" select="count(ancestor::scBlock)"/><xsl:element name="{concat('h', si($vCount &gt; 6, '6', $vCount))}"><xsl:apply-templates select="@*"/><xsl:apply-overlays/><xsl:apply-templates/></xsl:element></xsl:template>
<xsl:template match="addAttribute">
<xsl:variable name="vAttCo"><xsl:choose><xsl:when test="@filter='textOnly'"><xsl:value-of select="normalize-space(.)"/></xsl:when><xsl:otherwise><redirect:serialize omit-xml-declaration="yes"><xsl:value-of select="."/></redirect:serialize></xsl:otherwise></xsl:choose></xsl:variable>
<xsl:choose>
<xsl:when test="@name = 'lookForAlt'">
<xsl:attribute name="alt"><xsl:value-of select="si(string($vAttCo)='', ancestor::alternative/@alt, $vAttCo)" disable-output-escaping="yes"/></xsl:attribute>
</xsl:when>
<xsl:otherwise>
<xsl:attribute name="{@name}"><xsl:value-of select="$vAttCo" disable-output-escaping="yes"/></xsl:attribute>
</xsl:otherwise>
</xsl:choose>
</xsl:template>
	

<xsl:overlay match="*[parent::scTooltip/@basketKey and not(starts-with(local-name(),'scTooltip'))]" priority="1">
<xsl:variable name="vIdAnc" select="java:ensureIdOnCurrentResultElt($vDialog)"/>
<xsl:variable name="vTT" select="parent::scTooltip"/>
<xsl:variable name="vBasketKey" select="$vTT/@basketKey"/>
<xsl:variable name="vIdInBskt" select="concat($vBasketKey,$vTT/@itemKey)"/>
<xsl:if test="$vTT/@render = 'asTooltip' and count(//scBasket[@key=$vBasketKey])>0">
<xsl:value-of select="execute(java:append($vBufJs, concat('scTooltipMgr.registerTooltip(&quot;',$vIdAnc,'&quot;,&quot;',$vIdInBskt,'&quot;,&quot;',$vTT/@trigger,'&quot;,&quot;',$vTT/@class,'&quot;,&quot;',$vTT/@classRoot,'&quot;,{',$vTT/@options,'});')))"/>
</xsl:if>
</xsl:overlay>
<xsl:template match="scTooltip">
<xsl:variable name="vKey" select="string(@basketKey)"/>
<xsl:choose>
<xsl:when test="@basketKey and count(//scBasket[@key=$vKey])>0">
<xsl:apply-overlays/>
<xsl:apply-templates select="text()|child::*[not(starts-with(local-name(),'scTooltip'))]"/>
<xsl:variable name="vItemKey" select="string(@itemKey)"/>
<xsl:variable name="vIdInBskt" select="concat(@basketKey, @itemKey)"/>
<xsl:variable name="vEltRank"><xsl:for-each select="java:get($vBasketPool, $vKey)"><xsl:value-of select="si(@itemKey = $vItemKey, position(), '')"/></xsl:for-each></xsl:variable>
<xsl:variable name="vRefAnc" select="si(//scBasket[@key=$vKey][1]/@tagName = 'ol',$vEltRank,'*')"/>
<sup class="{addSuffixOnWords(@class, '_ref')}"><a href="#{$vIdInBskt}"><xsl:value-of select="$vRefAnc"/></a></sup>
</xsl:when>
<xsl:otherwise>
<xsl:variable name="vTTTitle"><redirect:serialize omit-xml-declaration="yes" method="html"><xsl:apply-templates select="scTooltipTitle/node()"/></redirect:serialize></xsl:variable>
<xsl:variable name="vTTContent"><redirect:serialize omit-xml-declaration="yes" method="html"><xsl:apply-templates select="scTooltipContent/node()"/></redirect:serialize></xsl:variable>
<xsl:variable name="vTTTrigger" select="@trigger"/>
<xsl:variable name="vTTAttr">scTooltipMgr.showTooltip(this,event,&quot;<xsl:value-of select="chaineProtegeJs(normalize-space($vTTContent))"/>&quot;,&quot;<xsl:value-of select="chaineProtegeJs(normalize-space($vTTTitle))"/>&quot;,&quot;<xsl:value-of select="@class"/>&quot;,&quot;<xsl:value-of select="@classRoot"/>&quot;,{<xsl:value-of select="@options"/>});</xsl:variable>
<xsl:for-each select="child::*[not(starts-with(local-name(),'scTooltip'))]">
<xsl:copy>
<xsl:attribute name="{$vTTTrigger}"><xsl:value-of select="$vTTAttr"/></xsl:attribute>
<xsl:apply-templates select="@*"/>
<xsl:apply-overlays/>
<xsl:apply-templates/>
</xsl:copy>
</xsl:for-each>
</xsl:otherwise>
</xsl:choose>
</xsl:template>
	

<xsl:variable name="vBufJs" select="java:java.lang.StringBuffer.new()"/>
<xsl:overlay match="body" mode="endTags"><xsl:if test="java:length($vBufJs) &gt; 0"><script type="text/javascript"><xsl:value-of select="java:toString($vBufJs)"/></script></xsl:if></xsl:overlay>

	

<xsl:variable name="vBasketPool" select="java:java.util.HashMap.new()"/>
	

<xsl:template match="scBlock"><div><xsl:apply-templates select="@*"/><xsl:apply-overlays/><xsl:apply-templates/></div></xsl:template>
<xsl:template match="scBlockTitle"/>
	
<xsl:template match="crossRef"/>

<xsl:overlay match="/">
<xsl:for-each select="//scBasket">
<xsl:variable name="vKey" select="string(@key)"/>
<xsl:variable name="vUnicity" select="java:java.util.HashSet.new()"/>
<xsl:value-of select="java:put($vBasketPool, $vKey, lxslt:nodeset(//scTooltip[@basketKey=$vKey][java:add($vUnicity, string(@itemKey))]))"/> 
</xsl:for-each>	
</xsl:overlay>
<xsl:template match="scBasket">
<xsl:variable name="vKey" select="string(@key)"/>
<xsl:variable name="vClass" select="@widgetClass"/>
<xsl:variable name="vChiTagName" select="si(@tagName='div','div','li')"/>
<xsl:variable name="vHasElts" select="count(java:get($vBasketPool, $vKey))>0"/>
<xsl:if test="$vHasElts or @suppressIfEmpty = 'no' ">
<xsl:element name="{@tagName}">
<xsl:attribute name="class"><xsl:value-of select="concat(@class,' ',$vClass)"/></xsl:attribute>
<xsl:for-each select="java:get($vBasketPool, $vKey)">
<xsl:choose>
<xsl:when test="local-name() = 'scTooltip'">
<xsl:variable name="vIdInBskt" select="concat(@basketKey, @itemKey)"/>
<xsl:element name="{$vChiTagName}">
<xsl:attribute name="class"><xsl:value-of select="addSuffixOnWords($vClass, '_it')"/></xsl:attribute>
<xsl:attribute name="id"><xsl:value-of select="$vIdInBskt"/></xsl:attribute>
<div class="{addSuffixOnWords($vClass, '_itti')}">
<xsl:choose>
<xsl:when test="scTooltipTitle"><xsl:apply-templates select="scTooltipTitle/node()"/></xsl:when>
<xsl:otherwise><xsl:attribute name="style">display:none;</xsl:attribute></xsl:otherwise>
</xsl:choose>
</div>
<div class="{addSuffixOnWords($vClass, '_itco')}">
<xsl:choose>
<xsl:when test="scTooltipContent"><xsl:apply-templates select="scTooltipContent/node()"/></xsl:when>
<xsl:otherwise><xsl:attribute name="style">display:none;</xsl:attribute></xsl:otherwise>
</xsl:choose>
</div>
</xsl:element>		
</xsl:when>
</xsl:choose>
</xsl:for-each>
</xsl:element>
</xsl:if>
</xsl:template>
	
	<xsl:template match="* | processing-instruction() | comment()"><xsl:copy><xsl:apply-templates select="@*"/><xsl:apply-overlays/><xsl:apply-templates/></xsl:copy></xsl:template>
	<xsl:template match="@* | text()"><xsl:copy/></xsl:template>
</xsl:stylesheet>
