<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" exclude-result-prefixes="sc sp" version="1.0"><xsl:output omit-xml-declaration="yes" indent="no" method="xml"/><xsl:param name="vComp"/><xsl:variable select="concat(getIdNode(..), '_Ascore')" name="vIdObj"/><xsl:template match="*"><script type="text/JavaScript">
var <xsl:value-of select="$vIdObj"/> = {

	fId : "<xsl:value-of select="getIdNode(..)"/>",
	fCurSeq : null,
	initSeq : function(pCodeSeq){
	try {
		if(pCodeSeq==null) return;
		if(this.fCurSeq!=null) this.closeSeq();
		this.fCurSeq = pCodeSeq;
		switch(this.fCurSeq) {

	case "score" : {
this.setMode(document.getElementById("<xsl:value-of select="$vIdObj"/>_N_score"), "visible");

		this.computeScore = function(pInput, pIdx) {
			this.fMinPts = 0;
			this.fMaxPts = 0;
			this.fScorePts = 0;
			var vRate;

		var vSubAssmnt = {fSession:"eval", compute:function(pParent, pId, pRate){
			this.fMinPts = scServices.assmntMgr.getMinPts(pId, this.fSession)||0;
			this.fScorePts = scServices.assmntMgr.getScorePts(pId, this.fSession)||0;
			this.fMaxPts = scServices.assmntMgr.getMaxPts(pId, this.fSession)||1;

			pParent.fMinPts += this.fMinPts;
			pParent.fScorePts += this.fScorePts;
			pParent.fMaxPts += this.fMaxPts;
		}};
<xsl:for-each select="sp:quiz">
		vSubAssmnt.compute(this, "<xsl:value-of select="si(@sc:refUri, getIdFromPath(@sc:refUri), getIdNode(.))"/>", <xsl:value-of select="si(sc:globalRating/@rate, sc:globalRating/@rate, '1')"/>);
</xsl:for-each>var vScoreSession = "eval";
			scServices.assmntMgr.setPts(this.fId, vScoreSession, this.fMinPts, this.fScorePts, this.fMaxPts);

						this.refreshScoresFeedbacks();
		}
scServices.assmntMgr.setCompletionStatus(this.fId, "eval", "complete"); 
window.scGlobalEval = this;
		this.handleAssmntPts = function(pEvent){if(<xsl:for-each select="sp:quiz">pEvent.fId=="<xsl:value-of select="si(@sc:refUri, getIdFromPath(@sc:refUri), getIdNode(.))"/>" || </xsl:for-each>false) this.computeScore();}
		scServices.assmntMgr.addEventListener(this);
		this.computeScore();

		break;
	}

		}
	}catch(e){alert("failed:::"+e)};
	},
	setMode : function(pElt, pMode){
		if(!pElt) return;
		switch(pMode) {
		case "collapsed" :
			pElt.style.display = "none";
			break;
		case "invisible" :
			pElt.style.display = "";
			pElt.style.visibility = "hidden";
			break;
		case "enabled" : 
			if(pElt.className.indexOf("buttonDisabled")&gt;=0) pElt.className = pElt.className.replace("buttonDisabled", "");
			pElt.setAttribute("href", "#");
		case "disabled" : 
			if(pMode=="disabled") {
				if(pElt.className.indexOf("buttonDisabled")&lt;0) pElt.className = pElt.className+" buttonDisabled";
				pElt.removeAttribute("href");
			}
		default :
			pElt.style.display = "";
			pElt.style.visibility = "";
		}
	},
	isDisabled : function(pButton){
		return pButton==null || pButton.className.indexOf("buttonDisabled")&gt;=0;
	},
	setToggleStatus : function(pButton, pOn){
		if(pButton==null) return;
		if(pOn){ 
			var vIdx = pButton.className.lastIndexOf("toggleButtonOff");
			pButton.className = (vIdx&gt;0 ? pButton.className.substring(0, vIdx) :  pButton.className) + " toggleButtonOn";
		} else {
			var vIdx = pButton.className.lastIndexOf("toggleButtonOn");
			pButton.className = (vIdx&gt;0 ? pButton.className.substring(0, vIdx) :  pButton.className) + " toggleButtonOff";
		}
	},
	isToggleOn : function(pButton){
		return pButton!=null &amp;&amp; pButton.className.indexOf("toggleButtonOn")&gt;=0;
	},
	
	closeSeq: function(){
		vForm = document.forms.<xsl:value-of select="$vIdObj"/>_form;
		switch(this.fCurSeq) {

	case "score" : {

		scServices.assmntMgr.removeEventListener(this);
		this.computeScore();

		break;
	}

		}
		this.fCurSeq = null;
	},
	getOnLoadSeq:function() {

			return "score";

	return null;
	},

	
	refreshScoresFeedbacks : function(){

		var vScoreNode = document.getElementById("<xsl:value-of select="$vIdObj"/>_SN37");

		var vScore = (Math.round((this.fScorePts-this.fMinPts) / (this.fMaxPts-this.fMinPts) * 100) * 1)+ 0;
if(vScore &gt; 99 &amp;&amp; true) {
			vScoreNode.innerHTML = "&lt;span&gt;Vous avez bien répondu à toutes les questions!"  + "&lt;/span&gt;";
			vScoreNode.className = "answBest";
		} else if(vScore &gt; 49 &amp;&amp; vScore &lt;= 99 &amp;&amp; true) {
			vScoreNode.innerHTML = "&lt;span&gt;Vous avez obtenu... " + vScore + "% de bonnes réponses.&lt;/span&gt;";
			vScoreNode.className = "answGood";
		} else if(vScore &lt;= 49 &amp;&amp; true) {
			vScoreNode.innerHTML = "&lt;span&gt;Vous avez obtenu... " + vScore + "% de bonnes réponses.&lt;/span&gt;";
			vScoreNode.className = "answBad";
		} else  {
			vScoreNode.innerHTML = "";
			vScoreNode.className = "";
		}
var vVal = (this.fScorePts - this.fMinPts) / (this.fMaxPts - this.fMinPts) * 100;
<xsl:for-each select="sc:feedbacks/sc:feedback">
			this.setMode(document.getElementById("<xsl:value-of select="$vIdObj"/>_F<xsl:value-of select="count(preceding-sibling::sc:feedback)"/>"), (<xsl:if test="@lt">vVal &lt; <xsl:value-of select="@lt"/> &amp;&amp; </xsl:if><xsl:if test="@let">vVal &lt;= <xsl:value-of select="@let"/> &amp;&amp; </xsl:if><xsl:if test="@gt">vVal &gt; <xsl:value-of select="@gt"/> &amp;&amp; </xsl:if><xsl:if test="@get">vVal &gt;= <xsl:value-of select="@get"/> &amp;&amp; </xsl:if>true) ? "visible" : "collapsed");
</xsl:for-each>
	},
	onLoad: function(){
		this.initSeq(this.getOnLoadSeq()); 
		var vNodeRoot = document.getElementById("<xsl:value-of select="$vIdObj"/>_A");
		vNodeRoot.style.display = "block"; 
	},
	onUnload: function(){
		this.closeSeq();
	},
	loadSortKey: "B",
	unloadSortKey: "B"
};

scOnLoads[scOnLoads.length] = <xsl:value-of select="$vIdObj"/>;
scOnUnloads[scOnUnloads.length] = <xsl:value-of select="$vIdObj"/>;
</script><div style="display:none;" id="{$vIdObj}_A"><div class="info"><div id="{$vIdObj}_N_score"><div id="{$vIdObj}_SN37"><span/></div></div><div class="feedback "><xsl:for-each select="sc:feedbacks/sc:feedback"><div id="{$vIdObj}_F{count(preceding-sibling::sc:feedback)}" class="WFeedbackEntry">[![agent=@<xsl:value-of select="getIdNode(.)"/>/xhtmlContent]!]</div></xsl:for-each></div></div></div></xsl:template></xsl:stylesheet>