<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet
 version="1.0" 
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
 
<xsl:output method="html" indent="yes" encoding="UTF-8" doctype-public="-//W3C//DTD HTML 4.01 Transitional//EN" doctype-system="http://www.w3.org/TR/html4/loose.dtd"/>
<xsl:param name="vDialog"/>
<xsl:param name="vAgent"/>
<xsl:template match="*">
		
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
<title>Simulateur de LMS Scorm</title>
<style type="text/css"><![CDATA[
		.dispDataChildren{
			border-left: 1px solid gray;
			padding-left : 3px;
			margin-left : 8px;
		}
		.dispDataNone{
			font-style: italic;
			color: gray;
			font-size: .8em;
		}
		.dispDataText{
			margin: 0px;
			color: #00017D;
		}
		
		ul.prv{ /* Menu root div */
			list-style: none;
			padding: 0em;
			margin: 5px;
			clear: both;
		}
		
		li.prv_li{
			padding: 2px 0px 0px 0px;
		}
		li.prv_li a,
		li.prv_li a:visited {
			text-decoration: none;
			color:#222222;
		}
		li.prv_li a:hover{
			text-decoration: none;
			color:#EEEEEE;
			background-color:#BBBBBB;
		}
		.prv_selected{
			color:#EEEEEE !important;
			background-color:#999999 !important;
		}
		
		ul.prv_list{
			margin-left:1em;
			padding:0px;
			list-style: none;
			padding: 0px 0px 0px 10px;
			font-weight: normal;
		}
		
		li.prv_folder{
			color:#333333;
			font-weight:bold;
		}
		
		.scorm_btn, .scorm_btnOn {
			border:#DDDDDD outset 1px;
			color:#00008B;
			padding:2px;
			text-decoration: none;
			margin:5px;
			background-color:#CCCCCC;
			font-familly:Verdana;
			font-size:0.8em;
			white-space: nowrap;
			line-height: 2em;
		}
		.scorm_btnOn {
			border:#DDDDDD inset 1px;
			background-color:#EEEEEE;
		}]]>
</style>
<script type="text/javascript"><![CDATA[
	    //
		function scOnLoad(){
			xSetNoSco();
		}
		
		function scOnUnload(){
		
		}
		
		var fApiSelected = "";
		var fLastItemSelected = null;
		function showItem(pUrl, pItemInTree){
			if(fLastItemSelected) fLastItemSelected.className="";
			fLastItemSelected = pItemInTree;
			if(pItemInTree) pItemInTree.className="prv_selected";
			xLoadSCO(pUrl);
		}
		
		function showCurrentData() {
			var vData;
			if(API) {
				vData = API._Fields;
			} else if(API_1484_11) {
				vData = API_1484_11._Fields;
			} else {
				alert("Aucun contenu SCORM n\&apos;est actuellement en cours d\&apos;exécution.");
				return;
			}
			var vFrm = document.getElementById("displayDataFrm");
			vFrm.style.display = "";
			var vCt = document.getElementById("displayDataCt");
			while(vCt.lastChild) vCt.removeChild(vCt.lastChild);
			xPublishData(vCt, vData);
			if(!vCt.hasChildNodes()) vCt.innerHTML = '<span class="dispDataNone">Aucune donnée enregistrée</span>';
		}
		function xPublishData(pParentNode, pObj) {
			if( pObj != null &&  typeof pObj == "object") {
				for (var vK in pObj) {
					var vContainer = pParentNode.appendChild(document.createElement("div"));
					vContainer.className = "dispDataCont";
					var vTitle = vContainer.appendChild(document.createElement("div"));
					vTitle.appendChild(document.createTextNode(vK));
					vTitle.className = "dispDataTitle";
					var vCh = vContainer.appendChild(document.createElement("div"));
					vCh.className = "dispDataChildren";
					xPublishData(vCh, pObj[vK]);
				}
			} else {
				var vPre = pParentNode.appendChild(document.createElement("pre"));
				vPre.className = "dispDataText";
				//pb affichage sur IE si text vide. Donc " " si null ou chaine vide, mais pas si number 0 ou false.
				if(pObj==null || pObj+""=="") pObj = " ";
				vPre.appendChild(document.createTextNode(pObj));
			}
		}
		
		function xReset(){
			var vSubTitleDiv = document.getElementById("scoSubTitle");
			while(vSubTitleDiv.lastChild) vSubTitleDiv.removeChild(vSubTitleDiv.lastChild);
			var vCt = document.getElementById("displayDataCt");
			while(vCt.lastChild) vCt.removeChild(vCt.lastChild);
			if(fLastItemSelected) fLastItemSelected.className="";
			fLastItemSelected = null;
			document.getElementById("btnNoSco").className = "scorm_btn";
			document.getElementById("btnSco12").className = "scorm_btn";
			document.getElementById("btnSco2k4").className = "scorm_btn";
			xLoadSCO("");
		}
		
		function xLoadSCO(pUrl) {
			var vFrmWin = window.frames["mainFrame"];
			vFrmWin.location.href = pUrl || "about:blank";
			//Chargement asynchrone du nouveau contexte (après le onunload).
			if(vFrmWin.addEventListener) {
				vFrmWin.addEventListener("unload", xUnloadSCO, false);
			} else if(vFrmWin.attachEvent){
				vFrmWin.attachEvent("onunload", xUnloadSCO);
			}
		}
		
		//Chargement asynchrone du nouveau contexte (après le onunload).
		function xUnloadSCO(pEvent){
			switch (fApiSelected) {
				case "scorm2k4" : {
					API = null;
					API_1484_11 = fLastItemSelected ? new Imp_API_1484_11(fLastItemSelected) : null;
					break;
				}
				case "scorm12" : {
					API = fLastItemSelected ? new Imp_API12(fLastItemSelected) : null;
					API_1484_11 = null;
					break;
				}
				default : {
					API = null;
					API_1484_11 = null;
				}
			}
		}
		
		function xSetSco2k4(){ 
			xReset();
			document.getElementById("scoSubTitle").appendChild(document.createTextNode("Environnement SCORM 2004"));
			document.getElementById("btnSco2k4").className = "scorm_btnOn";
			fApiSelected = "scorm2k4";
		}
		
		function xSetSco12(){ 
			xReset();
			document.getElementById("scoSubTitle").appendChild(document.createTextNode("Environnement SCORM 1.2"));
			document.getElementById("btnSco12").className = "scorm_btnOn";
			fApiSelected = "scorm12";
		}
		
		function xSetNoSco(){ 
			xReset();
			document.getElementById("scoSubTitle").appendChild(document.createTextNode("Aucun contexte SCORM défini"));
			document.getElementById("btnNoSco").className = "scorm_btnOn";
			fApiSelected = "";
		}
		
		function xListProperties(pObj){
			var vRes = "";
			var vProp = null;
			for (vProp in pObj) {
				try {
					vRes += vProp +'(' + pObj[vProp]+ ')'+ "\n";
				} catch(e){
					vRes += vProp +' -> toString in error\n';
				}
			}
			return vRes;
		}
		
		function xCloneObj(pObj) {
			if( pObj != null && typeof pObj == "object") {
				var vNew = {};
				for (var vK in pObj) vNew[vK] = xCloneObj(pObj[vK]);
				return vNew;
			} else return pObj;
		}
		
		function logInfo(pText){
			var vApi = API || API_1484_11;
			if(vApi && vApi._LastError != 0) {
				pText +="\n*** ERROR:" + vApi._LastError + " : " + (vApi.LMSGetDiagnostic ? vApi.LMSGetDiagnostic() : vApi.GetDiagnostic())+" ***";
			}
			if(window.console && console.log) console.log(pText);
		}]]>
		//
</script>

	
<script type="text/JavaScript"><![CDATA[
		//
		function Imp_API12(pOwner) {
			this._Fields = (pOwner && pOwner._Fields12) ? pOwner._Fields12 : {};
			this.fCurrentOwner = pOwner;
		}
		Imp_API12.prototype = {
			LMSInitialize : function(p) {
				this._LastError = 0;
				logInfo("SCORM12 LMSInitialize()");
				return "true";
			},
			
			LMSFinish : function(p) {
				this.LMSCommit("");
				this.fCurrentOwner = null;
				logInfo("SCORM12 LMSFinish()");
				return "true";
			},
			
			LMSGetValue : function(pKey) {
				this._LastError = 0;
				var vFields = pKey.split(".");
				var vLen = vFields.length;
				var vResult=null;
				switch(vFields[vLen-1]) {
					case "_version" : return "1.0";
					case "_children" : {
						vResult = this._children[vFields[vLen-2]] || "";
						if( ! vResult) this._LastError = 301;
						break;
					}
					case "_count" : {
						--vLen;
						var vCur = this._Fields;
						for(var i=0; i < vLen; i++) {
							var vF = vCur[vFields[i]];
							if(vF == null) return 0;
							vCur = vF;
						}
						var i = 0;
						for(var vKey in vCur) i++;
						vResult = i;
						break;
					}
					default : {
						var vCur = this._Fields;
						for(var i=0; i < vLen; i++) {
							var vF = vCur[vFields[i]];
							if(vF == null) return null;
							vCur = vF;
						}
						vResult = vCur;			
					}
				}
				logInfo("SCORM12 LMSGetValue('"+pKey+"') -> "+vResult);
				return vResult;
			},
			
			LMSSetValue : function(pKey, pValue) {
				this._LastError = 0;
				var vFields = pKey.split(".");
				var vCur = this._Fields;
				var imax = vFields.length-1;
				for(var i=0; i<imax; i++) {
					var vF = vCur[vFields[i]];
					if(vF == null) vCur = vCur[vFields[i]] = {}; else vCur = vF;
				}
				if( ! (vFields[imax] in vCur) || vCur[vFields[imax]] != pValue) {
					vCur[vFields[imax]] = pValue;
					this._Modif = true;
				}
				logInfo("SCORM12 LMSSetValue('"+pKey+"', '"+pValue+"')");
				return "true";
			},
		
			LMSCommit : function(p) {
				try {
					this._LastError = 0;
					if(this._Modif && this.fCurrentOwner) {
						this.fCurrentOwner._Fields12 = xCloneObj(this._Fields);
					}
					logInfo("SCORM12 LMSCommit()");
					return "true";
				}catch(e){
					this._LastError = 391;
					logInfo("SCORM12 LMSCommit()");
					return "false";
				}
			},
			
			LMSGetLastError : function() {
				return this._LastError;
			},
			
			LMSGetErrorString : function(pKeyError) {
				if (!pKeyError) return "";
				switch(pKeyError) {
					case 0 : return "";
					case 301 : return "Le modèle de donnée ne possède pas de fils.";
					case 391 : return "Enregistrement des données impossible. Veuillez contacter votre administrateur.";//General Commit Failure
				}
				return "";
			},
			
			LMSGetDiagnostic : function() {
				return this.LMSGetErrorString(this._LastError);
			},
			
			//interne
			_LastError : 0,
			_Fields : {},
			_Modif : false,
			_Session : null,
			_children : {
				"comments_from_learner" : "comment,location,timestamp",
				"comments_from_lms" : "comment,location,timestamp",
				"interactions" : "id,type,objectives,timestamp,correct_responses,weighting,learner_response,result,latency,description",
				"learner_preference" : "audio_level,language,delivery_speed,audio_captioning",
				"objectives" : "id,score,success_status,completion_status,description",
				"score" : "scaled,raw,min,max"
			}
			//
		}]]>
</script>
	
	
<script type="text/JavaScript"><![CDATA[
		//
		function Imp_API_1484_11 (pOwner) {
			this._Fields = (pOwner && pOwner._Fields2k4) ? pOwner._Fields2k4 : {};
			this.fCurrentOwner = pOwner;
		}
		Imp_API_1484_11.prototype = {
			Initialize : function(p) {
				this._LastError = 0;
				logInfo("SCORM2k4 Initialize()");
				return "true";
			},
			
			Terminate : function(p) {
				this.Commit("");
				this.fCurrentOwner = null;
				logInfo("SCORM2k4 Terminate()");
				return "true";
			},
			
			GetValue : function(pKey) {
				this._LastError = 0;
				var vFields = pKey.split(".");
				var vLen = vFields.length;
				var vResult = null;
				switch(vFields[vLen-1]) {
					case "_version" : return "1.0";
					case "_children" : {
						vResult = this._children[vFields[vLen-2]] || "";
						if( ! vResult) this._LastError = 301;
						break;
					}
					case "_count" : {
						--vLen;
						var vCur = this._Fields;
						for(var i=0; i < vLen; i++) {
							var vF = vCur[vFields[i]];
							if(vF == null) return 0;
							vCur = vF;
						}
						var i = 0;
						for(var vKey in vCur) i++;
						vResult = i;
						break;
					}
					default : {
						var vCur = this._Fields;
						for(var i=0; i < vLen; i++) {
							var vF = vCur[vFields[i]];
							if(vF == null) return null;
							vCur = vF;
						}
						vResult = vCur;
					}
				}
				logInfo("SCORM2k4 GetValue('"+pKey+"') -> "+vResult);
				return vResult;
			},
			
			SetValue : function(pKey, pValue) {
				this._LastError = 0;
				var vFields = pKey.split(".");
				var vCur = this._Fields;
				var imax = vFields.length-1;
				for(var i=0; i<imax; i++) {
					var vF = vCur[vFields[i]];
					if(vF == null) vCur = vCur[vFields[i]] = {}; else vCur = vF;
				}
				if( ! (vFields[imax] in vCur) || vCur[vFields[imax]] != pValue) {
					vCur[vFields[imax]] = pValue;
					this._Modif = true;
				}
				logInfo("SCORM2k4 SetValue('"+pKey+"', '"+pValue+"')");
				return "true";
			},
		
			Commit : function(p) {
				try {
					this._LastError = 0;
					if(this._Modif && this.fCurrentOwner) {
						this.fCurrentOwner._Fields2k4 = xCloneObj(this._Fields);
					}
					logInfo("SCORM2k4 Commit()");
					return "true";
				}catch(e){
					this._LastError = 391;
					logInfo("SCORM2k4 Commit()");
					return "false";
				}
			},
			
			GetLastError : function() {
				return this._LastError;
			},
			
			GetErrorString : function(pKeyError) {
				if (!pKeyError) return "";
				switch(pKeyError) {
					case 0 : return "";
					case 301 : return "Le modèle de donnée ne possède pas de fils.";
					case 391 : return "Enregistrement des données impossible. Veuillez contacter votre administrateur.";//General Commit Failure
				}
				return "";
			},
			
			GetDiagnostic : function() {
				return this.GetErrorString(this._LastError);
			},
			
			//interne
			_LastError : 0,
			_Fields : {},
			_Modif : false,
			_Session : null,
			_children : {
				"comments_from_learner" : "comment,location,timestamp",
				"comments_from_lms" : "comment,location,timestamp",
				"interactions" : "id,type,objectives,timestamp,correct_responses,weighting,learner_response,result,latency,description",
				"learner_preference" : "audio_level,language,delivery_speed,audio_captioning",
				"objectives" : "id,score,success_status,completion_status,description",
				"score" : "scaled,raw,min,max"
			}
		//
		}]]>
</script>
</head>
<body onload="scOnLoad();" onunload="scOnUnload();" style="margin:0px; height:100%;">
<!--  -->
<div style="position:absolute; width:30%; height:100%; overflow: auto; background-color:#777777;">
<div style="padding:3px;">
<div style="padding:3px; text-align:center;">
<div style="color:#EEEEEE; padding:2px; font-family:Verdana; font-size:1em;"><xsl:value-of select="resultatAgent('/@@/title')"/></div>
<a id="btnNoSco" class="scorm_btn" href="#" onclick="xSetNoSco(); return false;" style="text-decoration: line-through;">SCORM</a>
<a id="btnSco12" class="scorm_btn" href="#" onclick="xSetSco12(); return false;">SCORM 1.2</a>
<a id="btnSco2k4" class="scorm_btn" href="#" onclick="xSetSco2k4(); return false;">SCORM 2004</a>
<br/>
<span id="scoSubTitle" style="font-style:italic;font-size:1em; color:#EEEEEE;">Aucun contexte SCORM défini</span>
</div>
<div id="outline" style="font-family:Verdana; font-size:0.8em; background-color:#FFFFFF; padding: 2px 5px;; border: 2px solid #32190C; margin: 10px 0px;">
<ul class="prv">
<xsl:apply-templates select="parseXml(concat('&lt;outline&gt;', resultatAgent('/@@/scormCam'), '&lt;/outline&gt;'))/*" mode="out"/>
</ul>
</div>
<div style="padding:3px; text-align:center;">
<a id="btnDisplayData" class="scorm_btn" href="#" onclick="showCurrentData(); return false;">Voir les données SCORM...</a>
</div>
<div id="displayDataFrm" style="display: none; border: 2px solid #32190C; background-color:#F7E7DD; margin: 10px 0px;">
<div style="padding:3px; text-align:center;"><a id="btnDisplayData" class="scorm_btn" href="#" onclick="document.getElementById('displayDataFrm').style.display='none'; return false;">Masquer</a></div>
<div id="displayDataCt" style="padding: 5px; color:#32190C; font-family:Verdana; border-top: 1px solid #32190C;"></div>
</div>
<div style="text-align:right;color:#AAAAAA;font-size:0.8em; font-style:italic;padding:3px;">SCENARIviewer SCORM</div>
</div>
</div>
<div style="position:absolute; width:70%; height:100%; left: 30%;">
<iframe id="mainFrame"  name="mainFrame" style="border:none;" width="100%" height="100%" src="" marginwidth="0" marginheight="0" scrolling="auto" frameborder="0"></iframe>
</div>
<!--  -->
</body>
</html>
</xsl:template>
	
<xsl:template match="item[descendant::item[string-length(@href)&gt;0]]" mode="out">
<li class="prv_li prv_folder">
<xsl:choose>
<xsl:when test="string-length(@href)">
<a href="#" onclick="showItem('{@href}', this);return false;"><span><xsl:value-of select="@title"/></span></a>
</xsl:when>
<xsl:otherwise>
<span><xsl:value-of select="@title"/></span>
</xsl:otherwise>
</xsl:choose>
</li>
<ul class="prv_list">
<xsl:apply-templates mode="out"/>
</ul>
</xsl:template>
	
<xsl:template match="item" mode="out">
		
<xsl:if test="string-length(@href)">
<li class="prv_li">
<a href="#" onclick="showItem('{@href}', this);return false;"><span><xsl:value-of select="@title"/></span></a>
</li>
</xsl:if>
</xsl:template>
	
<xsl:template match="text()|@*" mode="out"/>

</xsl:stylesheet>

