<?xml version='1.0' encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:m="http://www.w3.org/1998/Math/MathML"
	version="1.0">
	
	<!-- ====================================================================== -->
	<!-- $id: glayout.xsl, 2002/17/05 Exp $
	     This file is part of the XSLT MathML Library distribution.
    	 See ./README or http://www.raleigh.ru/MathML/mmltex for
		 copyright and other information                                        -->
	<!-- ====================================================================== -->
<!-- FRK -->
	<xsl:template match="m:mfrac">
		<xsl:text> {</xsl:text>
		<xsl:choose>
			<xsl:when test="@numalign='right'">
				<xsl:text>{alignr{</xsl:text>
				<xsl:apply-templates select="./*[1]"/>
				<xsl:text>}}</xsl:text>
			</xsl:when>
			<xsl:when test="@numalign='left'">
				<xsl:text>{alignl{</xsl:text>
				<xsl:apply-templates select="./*[1]"/>
				<xsl:text>}}</xsl:text>
			</xsl:when>
			<xsl:when test="@numalign='center'">
				<xsl:text>{alignc{</xsl:text>
				<xsl:apply-templates select="./*[1]"/>
				<xsl:text>}}</xsl:text>
			</xsl:when>
			<xsl:otherwise>
				<xsl:text>{</xsl:text>
				<xsl:apply-templates select="./*[1]"/>
				<xsl:text>}</xsl:text>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:text> over </xsl:text>
		<xsl:choose>
			<xsl:when test="@denomalign='right'">
				<xsl:text>{alignr{</xsl:text>
				<xsl:apply-templates select="./*[2]"/>
				<xsl:text>}}</xsl:text>
			</xsl:when>
			<xsl:when test="@denomalign='left'">
				<xsl:text>{alignl{ </xsl:text>
				<xsl:apply-templates select="./*[2]"/>
				<xsl:text>}}</xsl:text>
			</xsl:when>
			<xsl:when test="@denomalign='center'">
				<xsl:text>{alignc{ </xsl:text>
				<xsl:apply-templates select="./*[2]"/>
				<xsl:text>}}</xsl:text>
			</xsl:when>
			<xsl:otherwise>
				<xsl:text>{</xsl:text>
				<xsl:apply-templates select="./*[2]"/>
				<xsl:text>}</xsl:text>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:text>}</xsl:text>
	</xsl:template>

	<xsl:template match="m:mroot">
		<xsl:choose>
			<xsl:when test="count(./*)=2">
				<xsl:text> nroot {</xsl:text>
				<xsl:apply-templates select="./*[2]"/>
				<xsl:text>}{</xsl:text>
				<xsl:apply-templates select="./*[1]"/>
				<xsl:text>}</xsl:text>
			</xsl:when>
			<xsl:otherwise>
				<!-- A voir??????????????????????????????????????????? -->
				<!-- number of argumnets is not 2 - code 25 -->
				<xsl:message>exception 25:</xsl:message>
				<xsl:text>\text{exception 25:}</xsl:text>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="m:msqrt">
		<xsl:text> sqrt{</xsl:text>
		<xsl:apply-templates/>
		<xsl:text>}</xsl:text>
	</xsl:template>

	<xsl:template match="m:mfenced">
		<xsl:choose>
			<xsl:when test="@open">
				<xsl:choose>
					<xsl:when test="@open ='{'">
						<xsl:text> left lbrace </xsl:text>
					</xsl:when>
					<xsl:when test="@open ='}'">
						<xsl:text> left rbrace </xsl:text>
					</xsl:when>
					<xsl:when test="@open ='|'">
						<xsl:text> left lline </xsl:text>
					</xsl:when>
					<xsl:when test="translate(@open,'[]()','{{{{')='{'">
						<xsl:text> left</xsl:text>
						<xsl:value-of select="@open"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="@open"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:text> left(</xsl:text>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:choose>
			<xsl:when test="count(./*)>1">
				<xsl:variable name="symbol">
					<xsl:choose>
						<xsl:when test="@separators">
							<xsl:call-template name="startspace">
								<xsl:with-param name="symbol" select="@separators"/>
							</xsl:call-template>
						</xsl:when>
						<xsl:otherwise>,</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<xsl:for-each select="./*">
					<xsl:apply-templates select="."/>
					<xsl:if test="not(position()=last())">
						<xsl:choose>
							<xsl:when test="position()>string-length($symbol)">
								<xsl:choose>
									<xsl:when test="substring($symbol,string-length($symbol)) = '|'">
										<xsl:text> divides </xsl:text>
									</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="substring($symbol,string-length($symbol))"/>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							<xsl:otherwise>
								<xsl:choose>
									<xsl:when test="substring($symbol,position(),1) = '|'">
										<xsl:text> divides </xsl:text>
									</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="substring($symbol,position(),1)"/>
									</xsl:otherwise>
								</xsl:choose>
								
							</xsl:otherwise>
						</xsl:choose>
					</xsl:if>
				</xsl:for-each>
			</xsl:when>
			<xsl:otherwise>
				<xsl:apply-templates/>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:choose>
			<xsl:when test="@close">
				<xsl:choose>
					<xsl:when test="translate(@close,'[]()','{{{{')='{'">
						<xsl:text> right</xsl:text>
						<xsl:value-of select="@open"/>
					</xsl:when>
					<xsl:when test="@close ='{'">
						<xsl:text> right lbrace </xsl:text>
					</xsl:when>
					<xsl:when test="@close ='}'">
						<xsl:text> right rbrace </xsl:text>
					</xsl:when>
					<xsl:when test="@close ='|'">
						<xsl:text> right rline </xsl:text>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="@close"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:text> right)</xsl:text>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<xsl:template match="m:mphantom">
		<xsl:text> phantom{</xsl:text>
		<xsl:apply-templates/>
		<xsl:text>}</xsl:text>
	</xsl:template>

	<xsl:template match="m:menclose">
		<xsl:choose>
			<xsl:when test="@notation = 'radical'">
				<xsl:text> sqrt{</xsl:text>
				<xsl:apply-templates/>
				<xsl:text>}</xsl:text>
			</xsl:when>
			<xsl:otherwise>
				<xsl:text> overline{</xsl:text>
				<xsl:apply-templates/>
				<xsl:text>}</xsl:text>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="m:mrow">
		<xsl:apply-templates/>
		<xsl:call-template name="testOpenBraces">
			<xsl:with-param name="node" select="."/>
		</xsl:call-template>
	</xsl:template>

	<xsl:template name="testOpenBraces">
		<xsl:param name="node"/>
		
		<!-- Création d'une chaine de caractère stockant les positions gauche/droite de chaque parenthèse/crochet...
			L=Left, R=Right,N=ne pas prendre
		-->
		<xsl:variable name="pos">
			<xsl:call-template name="getOpenCloseString">
				<xsl:with-param name="node" select="$node"></xsl:with-param>
			</xsl:call-template>
		</xsl:variable>
		<!-- si le noeud contient plus de parenthésage gauche que de droit alors fermer par des 'right none'-->
		<xsl:if test="contains($pos,'L')">
			<xsl:call-template name="addright">
				<xsl:with-param name="str">
					<!-- suppression des éventuels 'R' en début de chaine (déjà traités plus haut)-->
					<xsl:value-of select="concat('L',substring-after($pos,'L'))"/>
				</xsl:with-param>
				<xsl:with-param name="nb">
					<xsl:value-of select="0"/>
				</xsl:with-param>
			</xsl:call-template>
		</xsl:if>
	</xsl:template>

	<xsl:template match="m:mstyle">
		<xsl:if test="@color">
			<xsl:call-template name="color">
				<xsl:with-param name="color" select="@color"/>
			</xsl:call-template>
			<xsl:text>{</xsl:text>
		</xsl:if>
		<xsl:if test="@mathvariant">
			<xsl:choose>
				<xsl:when test="@mathvariant='normal'">
					<xsl:text>font serif {</xsl:text>
				</xsl:when>
				<xsl:when test="@mathvariant='serif'">
					<xsl:text>font serif {</xsl:text>
				</xsl:when>
				<xsl:when test="@mathvariant='bold'">
					<xsl:text> bold{</xsl:text>
				</xsl:when>
				<xsl:when test="@mathvariant='italic'">
					<xsl:text> ital{</xsl:text>
				</xsl:when>
				<xsl:when test="@mathvariant='sans-serif'">
					<xsl:text> font sans {</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>{</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:if>
		<xsl:apply-templates/>
		<xsl:if test="@color">
			<xsl:text>}</xsl:text>
		</xsl:if>
		<xsl:if test="@mathvariant">
			<xsl:text>}</xsl:text>
		</xsl:if>
		<xsl:call-template name="testOpenBraces">
			<xsl:with-param name="node" select="."/>
		</xsl:call-template>
	</xsl:template>
	
	<xsl:template match="m:merror">
		<xsl:apply-templates/>
	</xsl:template>
<!-- /FRK -->
	
</xsl:stylesheet>
