<?xml version='1.0' encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
        xmlns:m="http://www.w3.org/1998/Math/MathML"
                version='1.0'>
                
<!-- ====================================================================== -->
<!-- $Id: scripts.xsl,v 1.1.1.1 2002/10/26 14:20:06 shade33 Exp $
     This file is part of the XSLT MathML Library distribution.
     See ./README or http://www.raleigh.ru/MathML/mmltex for
     copyright and other information                                        -->
<!-- ====================================================================== -->

<!-- FRK -->
<xsl:template match="m:munderover">
    <xsl:variable name="base">
        <xsl:call-template name="startspace">
            <xsl:with-param name="symbol" select="./*[1]"/>
        </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="under">
        <xsl:call-template name="startspace">
            <xsl:with-param name="symbol" select="./*[2]"/>
        </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="over">
        <xsl:call-template name="startspace">
            <xsl:with-param name="symbol" select="./*[3]"/>
        </xsl:call-template>
    </xsl:variable>
    
    <xsl:choose>
        <xsl:when test="$over='&#x000AF;'"> <!-- overline-->
            <xsl:text> overline{</xsl:text>
            <xsl:call-template name="munder">
                <xsl:with-param name="base" select="$base"/>
                <xsl:with-param name="under" select="$under"/>
            </xsl:call-template>
            <xsl:text>}</xsl:text>
        </xsl:when>
        <xsl:when test="$over='&#x0FE37;'"> 
            <xsl:text>{{</xsl:text>
            <xsl:apply-templates select="./*[1]"/>
            <xsl:text>}</xsl:text>
            <xsl:text> overbrace{}}</xsl:text>
            <xsl:text> csub{</xsl:text>
            <xsl:apply-templates select="./*[2]"/>
            <xsl:text>}</xsl:text>
        </xsl:when>
        <xsl:when test="$under='&#x00332;'">    <!-- Underline -->
            <xsl:text> underline{</xsl:text>
            <xsl:call-template name="mover">
                <xsl:with-param name="base" select="$base"/>
                <xsl:with-param name="over" select="$over"/>
                <xsl:with-param name="pos_over" select="3"/>
            </xsl:call-template>
            <xsl:text>}</xsl:text>
        </xsl:when>
        <xsl:when test="$under='&#x0FE38;'">    
            <xsl:text>{{</xsl:text>
            <xsl:apply-templates select="./*[1]"/>
            <xsl:text>}</xsl:text>
            <xsl:text> underbrace{}}</xsl:text>
            <xsl:text> csup{</xsl:text>
            <xsl:apply-templates select="./*[3]"/>
            <xsl:text>}</xsl:text>
        </xsl:when>
        <!-- Cas repectifs du produit, du coproduit, des intégrale simples, doubles et triples ,des intégrales sur coutour simples, doubles et triples, de la somme -->
        <xsl:when test="starts-with(translate(./*[1],'&#x0220F;&#x02210;&#x0222B;&#x0222C;&#x0222D;&#x0222E;&#x0222F;&#x02230;&#x02211;',
            '&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;'),'&#x0CCCC;')"> 
            <xsl:apply-templates select="./*[1]"/>
            <xsl:text> from {</xsl:text>
            <xsl:apply-templates select="./*[2]"/>
            <xsl:text>} to {</xsl:text>
            <xsl:apply-templates select="./*[3]"/>
            <xsl:text>}</xsl:text>
        </xsl:when>
        <!-- Cas de la limite -->
        <xsl:when test="$base='lim'">
            <xsl:apply-templates select="./*[1]"/>
            <xsl:text> from {</xsl:text>
            <xsl:apply-templates select="./*[2]"/>
            <xsl:text>} to {</xsl:text>
            <xsl:apply-templates select="./*[3]"/>
            <xsl:text>}</xsl:text>
        </xsl:when>
        <xsl:otherwise>
            <xsl:apply-templates select="./*[1]"/>
            <xsl:text> csub{</xsl:text>
            <xsl:apply-templates select="./*[2]"/>
            <xsl:text>}csup{</xsl:text>
            <xsl:apply-templates select="./*[3]"/>
            <xsl:text>}</xsl:text>
        </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="m:mover">
    <xsl:call-template name="mover">
        <xsl:with-param name="base">
            <xsl:call-template name="startspace">
                <xsl:with-param name="symbol" select="./*[1]"/>
            </xsl:call-template>
        </xsl:with-param>
        <xsl:with-param name="over">
            <xsl:call-template name="startspace">
                <xsl:with-param name="symbol" select="./*[2]"/>
            </xsl:call-template>
        </xsl:with-param>
    </xsl:call-template>
</xsl:template>

<xsl:template match="m:munder">
    <xsl:call-template name="munder">
        <xsl:with-param name="base">
            <xsl:call-template name="startspace">
                <xsl:with-param name="symbol" select="./*[1]"/>
            </xsl:call-template>
        </xsl:with-param>
        <xsl:with-param name="under">
            <xsl:call-template name="startspace">
                <xsl:with-param name="symbol" select="./*[2]"/>
            </xsl:call-template>
        </xsl:with-param>
    </xsl:call-template>
</xsl:template>


<xsl:template name="mover">
    <xsl:param name="base"/>
    <xsl:param name="over"/>
    <xsl:param name="pos_over" select="2"/>
    <xsl:choose>
        <xsl:when test="$over='&#x000AF;'"> <!-- Overline-->
            <xsl:text> overline{</xsl:text>
            <xsl:apply-templates select="./*[1]"/>
            <xsl:text>}</xsl:text>
        </xsl:when>
        <xsl:when test="$over='&#x0FE37;'"> <!-- OverBrace remplacé par overline faute de disposé d'auter chose -->
            <xsl:text>{{</xsl:text>
            <xsl:apply-templates select="./*[1]"/>
            <xsl:text>}</xsl:text>
            <xsl:text> overbrace{}}</xsl:text>
        </xsl:when>
        <xsl:when test="$over='&#x02192;'">
            <xsl:text> widevec {</xsl:text>
            <xsl:apply-templates select="./*[1]"/>
            <xsl:text>}</xsl:text>
        </xsl:when>
        <xsl:when test="$over='&#x002DC;'">
            <xsl:text> widetilde {</xsl:text>
            <xsl:apply-templates select="./*[1]"/>
            <xsl:text>}</xsl:text>
        </xsl:when>
        <xsl:when test="$over='^'">
            <xsl:text> widehat {</xsl:text>
            <xsl:apply-templates select="./*[1]"/>
            <xsl:text>}</xsl:text>
        </xsl:when>
        <!-- Cas repectifs du produit, du coproduit, des intégrale simples, doubles et triples ,des intégrales sur coutour simples, doubles et triples, de la somme -->
        <xsl:when test="starts-with(translate(./*[1],'&#x0220F;&#x02210;&#x0222B;&#x0222C;&#x0222D;&#x0222E;&#x0222F;&#x02230;&#x02211;',
            '&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;'),'&#x0CCCC;')"> 
            <xsl:apply-templates select="./*[1]"/>
            <xsl:text> to {</xsl:text>  
            <xsl:apply-templates select="./*[2]"/>
            <xsl:text>}</xsl:text>  
        </xsl:when>
        <!-- Cas de la limite -->
        <xsl:when test="$base='lim'">
            <xsl:apply-templates select="./*[1]"/>
            <xsl:text> to {</xsl:text>  
            <xsl:apply-templates select="./*[2]"/>
            <xsl:text>}</xsl:text>  
        </xsl:when>
        <xsl:otherwise>
            <xsl:apply-templates select="./*[1]"/>
            <xsl:text> csup{</xsl:text>
            <xsl:apply-templates select="./*[$pos_over]"/>
            <xsl:text>}</xsl:text>
        </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template name="munder">
    <xsl:param name="base"/>
    <xsl:param name="under"/>
    <xsl:choose>
        <xsl:when test="$under='&#x00332;'">    <!-- UnderLine  -->
            <xsl:text> underline {</xsl:text>
            <xsl:apply-templates select="./*[1]"/>
            <xsl:text>}</xsl:text>
        </xsl:when>
        <xsl:when test="$under='&#x0FE38;'">    <!-- UnderBrace - implémenté avec underline faute de disposer d'autre chose -->
            <xsl:text>{{</xsl:text>
            <xsl:apply-templates select="./*[1]"/>
            <xsl:text>}</xsl:text>
            <xsl:text> underbrace{}}</xsl:text>
        </xsl:when>
        <!-- Cas repectifs du produit, du coproduit, des intégrale simples, doubles et triples ,des intégrales sur coutour simples, doubles et triples, de la somme -->
        <xsl:when test="starts-with(translate(./*[1],'&#x0220F;&#x02210;&#x0222B;&#x0222C;&#x0222D;&#x0222E;&#x0222F;&#x02230;&#x02211;',
            '&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;'),'&#x0CCCC;')"> 
            <xsl:apply-templates select="./*[1]"/>
            <xsl:text> from {</xsl:text>    
            <xsl:apply-templates select="./*[2]"/>
            <xsl:text>}</xsl:text>  
        </xsl:when>
        <!-- Cas de la limite -->
        <xsl:when test="$base='lim'">
            <xsl:apply-templates select="./*[1]"/>
            <xsl:text> from {</xsl:text>    
            <xsl:apply-templates select="./*[2]"/>
            <xsl:text>}</xsl:text>  
        </xsl:when>
        <xsl:otherwise>
            <xsl:apply-templates select="./*[1]"/>
            <xsl:text> csub{</xsl:text>
            <xsl:apply-templates select="./*[2]"/>
            <xsl:text>}</xsl:text>
        </xsl:otherwise>
    </xsl:choose>
</xsl:template>

    <xsl:template match="m:msubsup">
    <xsl:choose>
        <!-- Cas repectifs du produit, du coproduit, des intégrale simples, doubles et triples ,des intégrales sur coutour simples, doubles et triples, de la somme, de l'intersection, de l'union -->
        <xsl:when test="starts-with(translate(./*[1],'&#x0220F;&#x02210;&#x0222B;&#x0222C;&#x0222D;&#x0222E;&#x0222F;&#x02230;&#x02211;&#x022C2;&#x022C3;',
            '&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;'),'&#x0CCCC;')"> 
            <xsl:apply-templates select="./*[1]"/>
            <xsl:text>_{</xsl:text>
        </xsl:when>
        <!-- Cas de la limite -->
        <xsl:when test="starts-with(./*[1],'lim')">
            <xsl:apply-templates select="./*[1]"/>
            <xsl:text>_{</xsl:text>
        </xsl:when>
        <xsl:otherwise>
            <xsl:text>{</xsl:text>  
            <xsl:apply-templates select="./*[1]"/>
            <xsl:text>}_{</xsl:text>
            
        </xsl:otherwise>
    </xsl:choose>
    
    <xsl:apply-templates select="./*[2]"/>
    <xsl:text>}^{</xsl:text>    
    <xsl:apply-templates select="./*[3]"/>
    <xsl:text>}</xsl:text>  
</xsl:template>

<xsl:template match="m:msup">
    <xsl:choose>
        <!-- Cas repectifs du produit, du coproduit, des intégrale simples, doubles et triples ,des intégrales sur coutour simples, doubles et triples, de la somme, de l'intersection, de l'union -->
        <xsl:when test="starts-with(translate(./*[1],'&#x0220F;&#x02210;&#x0222B;&#x0222C;&#x0222D;&#x0222E;&#x0222F;&#x02230;&#x02211;&#x022C2;&#x022C3;',
            '&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;'),'&#x0CCCC;')"> 
            <xsl:apply-templates select="./*[1]"/>
            <xsl:text>^{</xsl:text>
        </xsl:when>
        <!-- Cas de la limite -->
        <xsl:when test="starts-with(./*[1],'lim')">
            <xsl:apply-templates select="./*[1]"/>
            <xsl:text>^{</xsl:text>
        </xsl:when>
        <xsl:otherwise>
            <xsl:text>{</xsl:text>  
            <xsl:apply-templates select="./*[1]"/>
            <xsl:text>}^{</xsl:text>
            
        </xsl:otherwise>
    </xsl:choose>
    <xsl:apply-templates select="./*[2]"/>
    <xsl:text>}</xsl:text>  
</xsl:template>

<xsl:template match="m:msub">
    <xsl:choose>
        <!-- Cas repectifs du produit, du coproduit, des intégrale simples, doubles et triples ,des intégrales sur coutour simples, doubles et triples, de la somme, de l'intersection, de l'union -->
        <xsl:when test="starts-with(translate(./*[1],'&#x0220F;&#x02210;&#x0222B;&#x0222C;&#x0222D;&#x0222E;&#x0222F;&#x02230;&#x02211;&#x022C2;&#x022C3;',
            '&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;&#x0CCCC;'),'&#x0CCCC;')"> 
            <xsl:apply-templates select="./*[1]"/>
            <xsl:text>_{</xsl:text>
            <xsl:apply-templates select="./*[2]"/>
            <xsl:text>}</xsl:text>  
        </xsl:when>
        <!-- Cas de la limite -->
        <xsl:when test="starts-with(./*[1],'lim')">
            <xsl:apply-templates select="./*[1]"/>
            <xsl:text>_{</xsl:text>
            <xsl:apply-templates select="./*[2]"/>
            <xsl:text>}</xsl:text>  
        </xsl:when>
        <!-- cas du caractère '°' -->
        <xsl:when test="starts-with(./*[1],'&#x0B0;')">
            <xsl:text>{binom{</xsl:text>
            <xsl:apply-templates select="./*[1]"/>
            <xsl:text>}{</xsl:text>
            <xsl:apply-templates select="./*[2]"/>
            <xsl:text>}}</xsl:text> 
        </xsl:when>
        <xsl:otherwise>
            <xsl:text>{</xsl:text>  
            <xsl:apply-templates select="./*[1]"/>
            <xsl:text>}_{</xsl:text>
            <xsl:apply-templates select="./*[2]"/>
            <xsl:text>}</xsl:text>  
        </xsl:otherwise>
    </xsl:choose>
</xsl:template>
    
<xsl:template match="m:mmultiscripts" mode="mprescripts">
    <xsl:for-each select="m:mprescripts/following-sibling::*">
        <xsl:if test="position() mod 2">
            <xsl:text>{}_{</xsl:text>
            <xsl:if test="local-name(.)!='none'">
                <xsl:apply-templates select="."/>
            </xsl:if>
            <xsl:text>}</xsl:text>  
        </xsl:if>
        <xsl:if test="not(position() mod 2)">
            <xsl:text>^{</xsl:text> 
            <xsl:if test="local-name(.)!='none'">
                <xsl:apply-templates select="."/>
            </xsl:if>
            <xsl:text>}</xsl:text>  
        </xsl:if>
    </xsl:for-each>
    <xsl:apply-templates select="./*[1]"/>
    <xsl:for-each select="m:mprescripts/preceding-sibling::*[position()!=last()]">
        <xsl:if test="position() mod 2">
            <xsl:text>{}_{</xsl:text>   
            <xsl:if test="local-name(.)!='none'">
                <xsl:apply-templates select="."/>
            </xsl:if>
            <xsl:text>}</xsl:text>  
        </xsl:if>
        <xsl:if test="not(position() mod 2)">
            <xsl:text>^{</xsl:text> 
            <xsl:if test="local-name(.)!='none'">
                <xsl:apply-templates select="."/>
            </xsl:if>
            <xsl:text>}</xsl:text>  
        </xsl:if>
    </xsl:for-each>
</xsl:template>

<xsl:template match="m:mmultiscripts">
    <xsl:choose>
        <xsl:when test="m:mprescripts">
            <xsl:apply-templates select="." mode="mprescripts"/>
        </xsl:when>
        <xsl:otherwise>
            <xsl:apply-templates select="./*[1]"/>
            <xsl:for-each select="*[position()>1]">
                <xsl:if test="position() mod 2 and local-name(.)!='none'">
                    <xsl:text>{}_{</xsl:text>   
                    <xsl:if test="local-name(.)!='none'">
                        <xsl:apply-templates select="."/>
                    </xsl:if>
                    <xsl:text>}</xsl:text>  
                </xsl:if>
                <xsl:if test="not(position() mod 2) and local-name(.)!='none'">
                    <xsl:text>^{</xsl:text> 
                    <xsl:if test="local-name(.)!='none'">
                        <xsl:apply-templates select="."/>
                    </xsl:if>
                    <xsl:text>}</xsl:text>  
                </xsl:if>
            </xsl:for-each>
        </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<!-- /FRK -->
    
</xsl:stylesheet>