<?xml version='1.0' encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
		xmlns:m="http://www.w3.org/1998/Math/MathML"
                version='1.0'>

<!-- ====================================================================== -->
<!-- $id: tables.xsl, 2002/17/05 Exp $
     This file is part of the XSLT MathML Library distribution.
     See ./README or http://www.raleigh.ru/MathML/mmltex for
     copyright and other information                                        -->
<!-- ====================================================================== -->

<!-- non traité -->
<!--<xsl:template match="m:mtd[@columnspan]">
	<xsl:text>\multicolumn{</xsl:text>
	<xsl:value-of select="@columnspan"/>
	<xsl:text>}{c}{</xsl:text>
	<xsl:apply-templates/>
	<xsl:text>}</xsl:text>
	<xsl:if test="count(following-sibling::*)>0">
		<xsl:text>&amp; </xsl:text>
	</xsl:if>
</xsl:template>-->

<!-- FRK -->
<xsl:template match="m:mtd">
	<xsl:param name="rowpos"/>
	<xsl:choose>
		<xsl:when test="count(child::*)=0">
			<xsl:text>{}</xsl:text>
		</xsl:when>
		<xsl:when test="@columnalign='left'">
			<xsl:text>alignl{</xsl:text>
			<xsl:apply-templates/>
			<xsl:call-template name="testOpenBraces">
				<xsl:with-param name="node" select="."/>
			</xsl:call-template>
			<xsl:text>}</xsl:text>
		</xsl:when>
		<xsl:when test="@columnalign='right'">
			<xsl:text>alignr{</xsl:text>
			<xsl:apply-templates/>
			<xsl:call-template name="testOpenBraces">
				<xsl:with-param name="node" select="."/>
			</xsl:call-template>
			<xsl:text>}</xsl:text>
		</xsl:when>
		<xsl:when test="@columnalign='center'">
			<xsl:text>alignc{</xsl:text>
			<xsl:apply-templates/>
			<xsl:call-template name="testOpenBraces">
				<xsl:with-param name="node" select="."/>
			</xsl:call-template>
			<xsl:text>}</xsl:text>
		</xsl:when>
		<xsl:otherwise>
			<xsl:apply-templates select="../.." mode="align">
				<xsl:with-param name="colpos" select="position()"/>
				<xsl:with-param name="rowpos" select="$rowpos"/>
			</xsl:apply-templates>
		</xsl:otherwise>
	</xsl:choose>
	
	<xsl:if test="count(following-sibling::*)>0">
<!--    this test valid for Sablotron, another form - test="not(position()=last())".
	Also for m:mtd[@columnspan] and m:mtr  -->
		<xsl:text> # </xsl:text>
	</xsl:if>
</xsl:template>

<xsl:template match="m:mtr">
	<xsl:apply-templates>
		<xsl:with-param name="rowpos" select="position()"/>
	</xsl:apply-templates>
	<xsl:if test="count(following-sibling::*)>0">
		<xsl:text> ## </xsl:text>
	</xsl:if>
</xsl:template>

	<xsl:template match="m:mtable" mode="align">
		<xsl:param name="colpos"/>
		<xsl:param name="rowpos"/>
		<xsl:variable name="numbercols" select="count(./m:mtr[1]/m:mtd[not(@columnspan)])+sum(./m:mtr[1]/m:mtd/@columnspan)"/>
		<xsl:choose>
			<xsl:when test="@columnalign">
				<xsl:variable name="colalign">
					<xsl:call-template name="colalign">
						<xsl:with-param name="colalign" select="@columnalign"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:variable name="align" select="substring($colalign,$colpos,1)"/>
				<xsl:choose>
					<xsl:when test="$align='r'">
						<xsl:text> alignr{</xsl:text>
						<xsl:apply-templates select="m:mtr[$rowpos]/m:mtd[$colpos]/*"></xsl:apply-templates>
						<xsl:call-template name="testOpenBraces">
							<xsl:with-param name="node" select="m:mtr[$rowpos]/m:mtd[$colpos]"></xsl:with-param>
						</xsl:call-template>
						<xsl:text>}</xsl:text>
					</xsl:when>
					<xsl:when test="$align='c'">
						<xsl:text> alignc{</xsl:text>
						<xsl:apply-templates select="m:mtr[$rowpos]/m:mtd[$colpos]/*"></xsl:apply-templates>
						<xsl:call-template name="testOpenBraces">
							<xsl:with-param name="node" select="m:mtr[$rowpos]/m:mtd[$colpos]"></xsl:with-param>
						</xsl:call-template>
						<xsl:text>}</xsl:text>
					</xsl:when>
					<xsl:when test="$align='l'">
						<xsl:text> alignl{</xsl:text>
						<xsl:apply-templates select="m:mtr[$rowpos]/m:mtd[$colpos]/*"></xsl:apply-templates>
						<xsl:call-template name="testOpenBraces">
							<xsl:with-param name="node" select="m:mtr[$rowpos]/m:mtd[$colpos]"></xsl:with-param>
						</xsl:call-template>
						<xsl:text>}</xsl:text>
					</xsl:when>
					<xsl:otherwise>
						<xsl:apply-templates select="m:mtr[$rowpos]/m:mtd[$colpos]/*"></xsl:apply-templates>
						<xsl:call-template name="testOpenBraces">
							<xsl:with-param name="node" select="m:mtr[$rowpos]/m:mtd[$colpos]"></xsl:with-param>
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:apply-templates select="m:mtr[$rowpos]/m:mtd[$colpos]/*"></xsl:apply-templates>
				<xsl:call-template name="testOpenBraces">
					<xsl:with-param name="node" select="m:mtr[$rowpos]/m:mtd[$colpos]"></xsl:with-param>
				</xsl:call-template>
		</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
		
<xsl:template match="m:mtable">
	<xsl:text> matrix {</xsl:text>
	<xsl:apply-templates/>
	<xsl:text>}</xsl:text>
</xsl:template>
	
<xsl:template name="colalign">
	<xsl:param name="colalign"/>
	<xsl:choose>
		<xsl:when test="contains($colalign,' ')">
			<xsl:value-of select="substring($colalign,1,1)"/>
			<xsl:call-template name="colalign">
				<xsl:with-param name="colalign" select="substring-after($colalign,' ')"/>
			</xsl:call-template>
		</xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="substring($colalign,1,1)"/>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template name="generate-string">
<!-- template from XSLT Standard Library v1.1 -->
    <xsl:param name="text"/>
    <xsl:param name="count"/>

    <xsl:choose>
      <xsl:when test="string-length($text) = 0 or $count &lt;= 0"/>

      <xsl:otherwise>
	<xsl:value-of select="$text"/>
	<xsl:call-template name="generate-string">
	  <xsl:with-param name="text" select="$text"/>
	  <xsl:with-param name="count" select="$count - 1"/>
	</xsl:call-template>
      </xsl:otherwise>
    </xsl:choose>
</xsl:template>
<!-- /FRK -->
	
</xsl:stylesheet>