<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:op="utc.fr:ics/opale3" xmlns:java="http://xml.apache.org/xslt/java" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns="http://www.utc.fr/ics/scenari/v3/primitive" exclude-result-prefixes="op java sp " >

<xsl:param name="vSpace"/>
<xsl:param name="vCode"/>

<xsl:template match="/sc:item">
<xsl:apply-templates select="op:courseUa"/>
</xsl:template>

<xsl:template match="sc:item/op:courseUa">
	<title><xsl:for-each xmlns:xsl="http://www.w3.org/1999/XSL/Transform" select="op:uM"><xsl:value-of select="sp:title"/></xsl:for-each></title>
<xsl:apply-templates/>
</xsl:template>


<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:courseUa/sp:courseUc[@sc:refUri]">
<xsl:if test="preceding-sibling::sp:*[@sc:refUri=current()/@sc:refUri and (name()='sp:courseUc' or name()='sp:practUc' or name()='sp:trainUc')]">
<cPbs><pb msg="Un item a été référencé plusieurs fois !" typ="Error">
<xsl:value-of select="formatStr('Veuillez supprimer une des références à l&apos;&apos;item %s.', @sc:refUri)"/>
</pb></cPbs>
</xsl:if>
<attrRef nm="op_courseUa:courseUc" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:courseUa/sp:practUc[@sc:refUri]">
<xsl:if test="preceding-sibling::sp:*[@sc:refUri=current()/@sc:refUri and (name()='sp:courseUc' or name()='sp:practUc' or name()='sp:trainUc')]">
<cPbs><pb msg="Un item a été référencé plusieurs fois !" typ="Error">
<xsl:value-of select="formatStr('Veuillez supprimer une des références à l&apos;&apos;item %s.', @sc:refUri)"/>
</pb></cPbs>
</xsl:if>
<attrRef nm="op_courseUa:practUc" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:courseUa/sp:trainUc[@sc:refUri]">
<xsl:if test="preceding-sibling::sp:*[@sc:refUri=current()/@sc:refUri and (name()='sp:courseUc' or name()='sp:practUc' or name()='sp:trainUc')]">
<cPbs><pb msg="Un item a été référencé plusieurs fois !" typ="Error">
<xsl:value-of select="formatStr('Veuillez supprimer une des références à l&apos;&apos;item %s.', @sc:refUri)"/>
</pb></cPbs>
</xsl:if>
<attrRef nm="op_courseUa:trainUc" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>



				
			

				
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:txt//sc:uLink[@role='acr']">
<attrRef nm="op_txt:uLinkTag:acr" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:txt//sc:uLink[@role='glos']">
<attrRef nm="op_txt:uLinkTag:glos" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:txt//sc:uLink[@role='bib']">
<attrRef nm="op_txt:uLinkTag:bib" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:txt//sc:uLink[@role='ref']">
<attrRef nm="op_txt:uLinkTag:ref" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:txt//sc:uLink[@role='docLnk']">
<attrRef nm="op_txt:uLinkTag:docLnk" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:txt//sc:uLink[@role='resLnk']">
<attrRef nm="op_txt:uLinkTag:resLnk" refUri="{@sc:refUri}"/>
</xsl:template>
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:txt//sc:inlineImg[@role='form']">
<attrRef nm="op_txt:inlineImgTag:form" refUri="{@sc:refUri}"/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:txt//sc:inlineImg[@role='ico']">
<attrRef nm="op_txt:inlineImgTag:ico" refUri="{@sc:refUri}"/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:trainUc/sp:quiz[@sc:refUri]">
<attrRef nm="op_trainUc:quiz" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>

<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:res/sp:img[@sc:refUri]">
<attrRef nm="op_res:img" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:res/sp:tab[@sc:refUri]">
<attrRef nm="op_res:tab" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:res/sp:graph[@sc:refUri]">
<attrRef nm="op_res:graph" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:res/sp:vid[@sc:refUri]">
<attrRef nm="op_res:vid" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:res/sp:int[@sc:refUri]">
<attrRef nm="op_res:int" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:res/sp:zoom[@sc:refUri]">
<attrRef nm="op_res:zoom" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:res/sp:form[@sc:refUri]">
<attrRef nm="op_res:form" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>


				
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:qTxt//sc:uLink[@role='acr']">
<attrRef nm="op_qTxt:uLinkTag:acr" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:qTxt//sc:uLink[@role='glos']">
<attrRef nm="op_qTxt:uLinkTag:glos" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:qTxt//sc:uLink[@role='bib']">
<attrRef nm="op_qTxt:uLinkTag:bib" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:qTxt//sc:uLink[@role='ref']">
<attrRef nm="op_qTxt:uLinkTag:ref" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:qTxt//sc:uLink[@role='docLnk']">
<attrRef nm="op_qTxt:uLinkTag:docLnk" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:qTxt//sc:uLink[@role='resLnk']">
<attrRef nm="op_qTxt:uLinkTag:resLnk" refUri="{@sc:refUri}"/>
</xsl:template>
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:qTxt//sc:inlineImg[@role='form']">
<attrRef nm="op_qTxt:inlineImgTag:form" refUri="{@sc:refUri}"/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:qTxt//sc:inlineImg[@role='ico']">
<attrRef nm="op_qTxt:inlineImgTag:ico" refUri="{@sc:refUri}"/>
</xsl:template>

<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:txtRes/sp:res[@sc:refUri]">
<attrRef nm="op_txtRes:res" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>




<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:labelImg/sp:img[@sc:refUri]">
<attrRef nm="op_labelImg:img" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>

				
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:labelTxt//sc:uLink[@role='acr']">
<attrRef nm="op_labelTxt:uLinkTag:acr" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:labelTxt//sc:uLink[@role='glos']">
<attrRef nm="op_labelTxt:uLinkTag:glos" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:labelTxt//sc:uLink[@role='ref']">
<attrRef nm="op_labelTxt:uLinkTag:ref" refUri="{@sc:refUri}"/>
</xsl:template>
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:labelTxt//sc:inlineImg[@role='form']">
<attrRef nm="op_labelTxt:inlineImgTag:form" refUri="{@sc:refUri}"/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:labelTxt//sc:inlineImg[@role='ico']">
<attrRef nm="op_labelTxt:inlineImgTag:ico" refUri="{@sc:refUri}"/>
</xsl:template>



				
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:clozeTxt//sc:uLink[@role='acr']">
<attrRef nm="op_clozeTxt:uLinkTag:acr" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:clozeTxt//sc:uLink[@role='glos']">
<attrRef nm="op_clozeTxt:uLinkTag:glos" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:clozeTxt//sc:uLink[@role='bib']">
<attrRef nm="op_clozeTxt:uLinkTag:bib" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:clozeTxt//sc:uLink[@role='ref']">
<attrRef nm="op_clozeTxt:uLinkTag:ref" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:clozeTxt//sc:uLink[@role='docLnk']">
<attrRef nm="op_clozeTxt:uLinkTag:docLnk" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:clozeTxt//sc:uLink[@role='resLnk']">
<attrRef nm="op_clozeTxt:uLinkTag:resLnk" refUri="{@sc:refUri}"/>
</xsl:template>
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:clozeTxt//sc:inlineImg[@role='form']">
<attrRef nm="op_clozeTxt:inlineImgTag:form" refUri="{@sc:refUri}"/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:clozeTxt//sc:inlineImg[@role='ico']">
<attrRef nm="op_clozeTxt:inlineImgTag:ico" refUri="{@sc:refUri}"/>
</xsl:template>








<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:genRef/sp:ref[@sc:refUri]">
<xsl:if test="preceding-sibling::sp:*[@sc:refUri=current()/@sc:refUri and (name()='sp:ref')]">
<cPbs><pb msg="Un item a été référencé plusieurs fois !" typ="Error">
<xsl:value-of select="formatStr('Veuillez supprimer une des références à l&apos;&apos;item %s.', @sc:refUri)"/>
</pb></cPbs>
</xsl:if>
<attrRef nm="op_genRef:ref" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>



<xsl:template match="text()|@*"/>
</xsl:stylesheet>