<?xml version='1.0' encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:m="http://www.w3.org/1998/Math/MathML"
     xmlns="http://www.w3.org/1998/Math/MathML"
     version='1.0'
     exclude-result-prefixes="m">
     
     <xsl:output method="xml" indent="yes" encoding="UTF-8" omit-xml-declaration="no" version="1.0"/>
     
     <!-- ====================================================================== -->
     <!-- $id: mmltex.ss.xsl, 2002/22/11 Exp $
          This file is part of the XSLT MathML Library distribution.
          See ./README or http://www.raleigh.ru/MathML/mmltex for
          copyright and other information                                        -->
     <!-- ====================================================================== -->
     
     <xsl:include href="intern://~param/OpaleStarter-3_1/ss/mml/mml2oo/tokens.ss.xsl"/>
     <xsl:include href="intern://~param/OpaleStarter-3_1/ss/mml/mml2oo/glayout.ss.xsl"/>
     <xsl:include href="intern://~param/OpaleStarter-3_1/ss/mml/mml2oo/scripts.ss.xsl"/>
     <xsl:include href="intern://~param/OpaleStarter-3_1/ss/mml/mml2oo/tables.ss.xsl"/>
     <xsl:include href="intern://~param/OpaleStarter-3_1/ss/mml/mml2oo/entities.ss.xsl"/>
     <xsl:include href="intern://~param/OpaleStarter-3_1/ss/mml/mml2oo/cmarkup.ss.xsl"/>
     
     <!-- Note: variables colora (template color) and symbola (template startspace) only for Sablotron -->
     
     <xsl:template name="startspace">
          <xsl:param name="symbol"/>
          <xsl:if test="contains($symbol,' ')">
               <xsl:variable name="symbola" select="concat(substring-before($symbol,' '),substring-after($symbol,' '))"/>
               <xsl:call-template name="startspace">
                    <xsl:with-param name="symbol" select="$symbola"/>
               </xsl:call-template>
          </xsl:if>
          <xsl:if test="not(contains($symbol,' '))">
               <xsl:value-of select="$symbol"/>
          </xsl:if>
     </xsl:template>
     
     <xsl:strip-space elements="m:*"/>
     
     <xsl:template match="m:math">
          <math>
              <!-- Pas de copie du MathML; pose des pbs lorsque le latex est 'inline'
              <xsl:copy-of select="child::*"/>
               -->
              <annotation  encoding="StarMath 5.0"><xsl:apply-templates/></annotation>
          </math>
     </xsl:template>

     <xsl:template match="m:annotation"></xsl:template>

</xsl:stylesheet>